package allen.edwall.transits;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "allen.edwall.transits", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "allen.edwall.transits", "main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.sample1.SweDate _vv3 = null;
public static anywheresoftware.b4a.sample1.SwissEph _vvv2 = null;
public static String[] _asp_names = null;
public static String _last_interp_text = "";
public static String[] _month_names = null;
public static String _natal_data = "";
public static String[] _p_names = null;
public static String _prev_text = "";
public static String _transit_data = "";
public static String _natal_data_header = "";
public static String _transit_data_header = "";
public static int[][] _aspect_present = null;
public static int _flag_help = 0;
public static int[] _pl_glyph = null;
public static int[] _sign_glyph = null;
public static int[] _spot_filled = null;
public static float _tz_offset = 0f;
public static double _current_jd = 0;
public static double _v0 = 0;
public static double[] _vv4 = null;
public static double[] _vvv1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnchange = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btndate = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnhelp = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnprevious = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnnext = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnwheel_text = null;
public anywheresoftware.b4a.objects.ButtonWrapper _vvv3 = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _v5 = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _v6 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _chkdebug = null;
public anywheresoftware.b4a.objects.drawable.CanvasWrapper _vv1 = null;
public anywheresoftware.b4a.keywords.constants.TypefaceWrapper _v7 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 28;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 29;BA.debugLine="Activity.LoadLayout(\"Layout\")";
mostCurrent._activity.LoadLayout("Layout",mostCurrent.activityBA);
 //BA.debugLineNum = 31;BA.debugLine="Bmp1.Initialize(File.DirAssets, \"calendar.png\")";
mostCurrent._v5.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"calendar.png");
 //BA.debugLineNum = 32;BA.debugLine="Bmp2.Initialize(File.DirAssets, \"clock.png\")";
mostCurrent._v6.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"clock.png");
 //BA.debugLineNum = 34;BA.debugLine="HamburgFont = Typeface.LoadFromAssets(\"HamburgSymbols.ttf\")";
mostCurrent._v7.setObject((android.graphics.Typeface)(anywheresoftware.b4a.keywords.Common.Typeface.LoadFromAssets("HamburgSymbols.ttf")));
 //BA.debugLineNum = 38;BA.debugLine="p_names(0) = \"Sun\"";
_p_names[(int)(0)] = "Sun";
 //BA.debugLineNum = 39;BA.debugLine="p_names(1) = \"Moon\"";
_p_names[(int)(1)] = "Moon";
 //BA.debugLineNum = 40;BA.debugLine="p_names(2) = \"Mercury\"";
_p_names[(int)(2)] = "Mercury";
 //BA.debugLineNum = 41;BA.debugLine="p_names(3) = \"Venus\"";
_p_names[(int)(3)] = "Venus";
 //BA.debugLineNum = 42;BA.debugLine="p_names(4) = \"Mars\"";
_p_names[(int)(4)] = "Mars";
 //BA.debugLineNum = 43;BA.debugLine="p_names(5) = \"Jupiter\"";
_p_names[(int)(5)] = "Jupiter";
 //BA.debugLineNum = 44;BA.debugLine="p_names(6) = \"Saturn\"";
_p_names[(int)(6)] = "Saturn";
 //BA.debugLineNum = 45;BA.debugLine="p_names(7) = \"Uranus\"";
_p_names[(int)(7)] = "Uranus";
 //BA.debugLineNum = 46;BA.debugLine="p_names(8) = \"Neptune\"";
_p_names[(int)(8)] = "Neptune";
 //BA.debugLineNum = 47;BA.debugLine="p_names(9) = \"Pluto\"";
_p_names[(int)(9)] = "Pluto";
 //BA.debugLineNum = 49;BA.debugLine="asp_names(0) = \"\"";
_asp_names[(int)(0)] = "";
 //BA.debugLineNum = 50;BA.debugLine="asp_names(1) = \"\"";
_asp_names[(int)(1)] = "";
 //BA.debugLineNum = 51;BA.debugLine="asp_names(2) = \" Conjunct \"";
_asp_names[(int)(2)] = " Conjunct ";
 //BA.debugLineNum = 52;BA.debugLine="asp_names(3) = \" Sextile \"";
_asp_names[(int)(3)] = " Sextile ";
 //BA.debugLineNum = 53;BA.debugLine="asp_names(4) = \" Square \"";
_asp_names[(int)(4)] = " Square ";
 //BA.debugLineNum = 54;BA.debugLine="asp_names(5) = \" Trine \"";
_asp_names[(int)(5)] = " Trine ";
 //BA.debugLineNum = 55;BA.debugLine="asp_names(6) = \" Opposite \"";
_asp_names[(int)(6)] = " Opposite ";
 //BA.debugLineNum = 57;BA.debugLine="month_names(1) = \"Jan\"";
_month_names[(int)(1)] = "Jan";
 //BA.debugLineNum = 58;BA.debugLine="month_names(2) = \"Feb\"";
_month_names[(int)(2)] = "Feb";
 //BA.debugLineNum = 59;BA.debugLine="month_names(3) = \"Mar\"";
_month_names[(int)(3)] = "Mar";
 //BA.debugLineNum = 60;BA.debugLine="month_names(4) = \"Apr\"";
_month_names[(int)(4)] = "Apr";
 //BA.debugLineNum = 61;BA.debugLine="month_names(5) = \"May\"";
_month_names[(int)(5)] = "May";
 //BA.debugLineNum = 62;BA.debugLine="month_names(6) = \"Jun\"";
_month_names[(int)(6)] = "Jun";
 //BA.debugLineNum = 63;BA.debugLine="month_names(7) = \"Jul\"";
_month_names[(int)(7)] = "Jul";
 //BA.debugLineNum = 64;BA.debugLine="month_names(8) = \"Aug\"";
_month_names[(int)(8)] = "Aug";
 //BA.debugLineNum = 65;BA.debugLine="month_names(9) = \"Sep\"";
_month_names[(int)(9)] = "Sep";
 //BA.debugLineNum = 66;BA.debugLine="month_names(10) = \"Oct\"";
_month_names[(int)(10)] = "Oct";
 //BA.debugLineNum = 67;BA.debugLine="month_names(11) = \"Nov\"";
_month_names[(int)(11)] = "Nov";
 //BA.debugLineNum = 68;BA.debugLine="month_names(12) = \"Dec\"";
_month_names[(int)(12)] = "Dec";
 //BA.debugLineNum = 70;BA.debugLine="pl_glyph(0) = 81";
_pl_glyph[(int)(0)] = (int)(81);
 //BA.debugLineNum = 71;BA.debugLine="pl_glyph(1) = 87";
_pl_glyph[(int)(1)] = (int)(87);
 //BA.debugLineNum = 72;BA.debugLine="pl_glyph(2) = 69";
_pl_glyph[(int)(2)] = (int)(69);
 //BA.debugLineNum = 73;BA.debugLine="pl_glyph(3) = 82";
_pl_glyph[(int)(3)] = (int)(82);
 //BA.debugLineNum = 74;BA.debugLine="pl_glyph(4) = 84";
_pl_glyph[(int)(4)] = (int)(84);
 //BA.debugLineNum = 75;BA.debugLine="pl_glyph(5) = 89";
_pl_glyph[(int)(5)] = (int)(89);
 //BA.debugLineNum = 76;BA.debugLine="pl_glyph(6) = 85";
_pl_glyph[(int)(6)] = (int)(85);
 //BA.debugLineNum = 77;BA.debugLine="pl_glyph(7) = 73";
_pl_glyph[(int)(7)] = (int)(73);
 //BA.debugLineNum = 78;BA.debugLine="pl_glyph(8) = 79";
_pl_glyph[(int)(8)] = (int)(79);
 //BA.debugLineNum = 79;BA.debugLine="pl_glyph(9) = 80";
_pl_glyph[(int)(9)] = (int)(80);
 //BA.debugLineNum = 81;BA.debugLine="sign_glyph(1) = 97";
_sign_glyph[(int)(1)] = (int)(97);
 //BA.debugLineNum = 82;BA.debugLine="sign_glyph(2) = 115";
_sign_glyph[(int)(2)] = (int)(115);
 //BA.debugLineNum = 83;BA.debugLine="sign_glyph(3) = 100";
_sign_glyph[(int)(3)] = (int)(100);
 //BA.debugLineNum = 84;BA.debugLine="sign_glyph(4) = 102";
_sign_glyph[(int)(4)] = (int)(102);
 //BA.debugLineNum = 85;BA.debugLine="sign_glyph(5) = 103";
_sign_glyph[(int)(5)] = (int)(103);
 //BA.debugLineNum = 86;BA.debugLine="sign_glyph(6) = 104";
_sign_glyph[(int)(6)] = (int)(104);
 //BA.debugLineNum = 87;BA.debugLine="sign_glyph(7) = 106";
_sign_glyph[(int)(7)] = (int)(106);
 //BA.debugLineNum = 88;BA.debugLine="sign_glyph(8) = 107";
_sign_glyph[(int)(8)] = (int)(107);
 //BA.debugLineNum = 89;BA.debugLine="sign_glyph(9) = 108";
_sign_glyph[(int)(9)] = (int)(108);
 //BA.debugLineNum = 90;BA.debugLine="sign_glyph(10) = 122";
_sign_glyph[(int)(10)] = (int)(122);
 //BA.debugLineNum = 91;BA.debugLine="sign_glyph(11) = 120";
_sign_glyph[(int)(11)] = (int)(120);
 //BA.debugLineNum = 92;BA.debugLine="sign_glyph(12) = 99";
_sign_glyph[(int)(12)] = (int)(99);
 //BA.debugLineNum = 94;BA.debugLine="d2r = 0.0174532			'convert degrees into radians";
_v0 = 0.0174532;
 //BA.debugLineNum = 97;BA.debugLine="cvsLayer.Initialize(Activity)";
mostCurrent._vv1.Initialize((android.view.View)(mostCurrent._activity.getObject()));
 //BA.debugLineNum = 100;BA.debugLine="EditText1.InputType = EditText1.INPUT_TYPE_NONE				'do not allow software keypad to appear";
mostCurrent._edittext1.setInputType(mostCurrent._edittext1.INPUT_TYPE_NONE);
 //BA.debugLineNum = 101;BA.debugLine="EditText1.SingleLine = False													'necessary";
mostCurrent._edittext1.setSingleLine(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 102;BA.debugLine="EditText1.Wrap = True";
mostCurrent._edittext1.setWrap(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 104;BA.debugLine="If FirstTime = False Then";
if (_firsttime==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 105;BA.debugLine="btnPrevious.Enabled = True";
mostCurrent._btnprevious.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 106;BA.debugLine="btnNext.Enabled = True";
mostCurrent._btnnext.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 107;BA.debugLine="btnWheel_Text.Enabled = True";
mostCurrent._btnwheel_text.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 109;BA.debugLine="EditText1.Text = last_interp_text";
mostCurrent._edittext1.setText((Object)(_last_interp_text));
 };
 //BA.debugLineNum = 111;BA.debugLine="End Sub";
return "";
}
public static String  _btnchange_click() throws Exception{
anywheresoftware.b4a.agraham.dialogs.InputDialog.DateDialog _dd = null;
anywheresoftware.b4a.agraham.dialogs.InputDialog.TimeDialog _td = null;
int _m = 0;
int _d = 0;
int _y = 0;
int _h = 0;
int _n = 0;
anywheresoftware.b4a.objects.collections.List _list1 = null;
float _tz = 0f;
String _ret = "";
 //BA.debugLineNum = 254;BA.debugLine="Sub btnChange_Click";
 //BA.debugLineNum = 255;BA.debugLine="Dim dd As DateDialog";
_dd = new anywheresoftware.b4a.agraham.dialogs.InputDialog.DateDialog();
 //BA.debugLineNum = 256;BA.debugLine="Dim td As TimeDialog";
_td = new anywheresoftware.b4a.agraham.dialogs.InputDialog.TimeDialog();
 //BA.debugLineNum = 257;BA.debugLine="Dim M, d, y, h, n As Int";
_m = 0;
_d = 0;
_y = 0;
_h = 0;
_n = 0;
 //BA.debugLineNum = 258;BA.debugLine="Dim List1 As List";
_list1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 259;BA.debugLine="Dim tz As Float";
_tz = 0f;
 //BA.debugLineNum = 261;BA.debugLine="EditText1.Visible = True";
mostCurrent._edittext1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 264;BA.debugLine="If File.Exists(File.DirInternal, \"natal_data.txt\") = True Then";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"natal_data.txt")==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 265;BA.debugLine="List1 = File.ReadList(File.DirInternal, \"natal_data.txt\")";
_list1 = anywheresoftware.b4a.keywords.Common.File.ReadList(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"natal_data.txt");
 //BA.debugLineNum = 267;BA.debugLine="M = List1.Get(0)";
_m = (int)(BA.ObjectToNumber(_list1.Get((int)(0))));
 //BA.debugLineNum = 268;BA.debugLine="d = List1.Get(1)";
_d = (int)(BA.ObjectToNumber(_list1.Get((int)(1))));
 //BA.debugLineNum = 269;BA.debugLine="y = List1.Get(2)";
_y = (int)(BA.ObjectToNumber(_list1.Get((int)(2))));
 //BA.debugLineNum = 271;BA.debugLine="h = List1.Get(3)";
_h = (int)(BA.ObjectToNumber(_list1.Get((int)(3))));
 //BA.debugLineNum = 272;BA.debugLine="n = List1.Get(4)";
_n = (int)(BA.ObjectToNumber(_list1.Get((int)(4))));
 //BA.debugLineNum = 274;BA.debugLine="tz = List1.Get(5)";
_tz = (float)(BA.ObjectToNumber(_list1.Get((int)(5))));
 //BA.debugLineNum = 276;BA.debugLine="dd.Year = y";
_dd.setYear(_y);
 //BA.debugLineNum = 277;BA.debugLine="dd.Month = M";
_dd.setMonth(_m);
 //BA.debugLineNum = 278;BA.debugLine="dd.DayOfMonth = d";
_dd.setDayOfMonth(_d);
 //BA.debugLineNum = 280;BA.debugLine="ret = dd.Show(\"Set your birth date\", \"Tell me your birth date\", \"OK\", \"\", \"\", Bmp1)";
_ret = BA.NumberToString(_dd.Show("Set your birth date","Tell me your birth date","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v5.getObject())));
 //BA.debugLineNum = 283;BA.debugLine="td.Hour = h";
_td.setHour(_h);
 //BA.debugLineNum = 284;BA.debugLine="td.Minute = n";
_td.setMinute(_n);
 //BA.debugLineNum = 285;BA.debugLine="td.Is24Hours = True";
_td.setIs24Hours(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 287;BA.debugLine="ret = td.Show(\"Set your birth time (use 24-hr time)\", \"Tell me your birth time\", \"OK\", \"\", \"\", Bmp2)";
_ret = BA.NumberToString(_td.Show("Set your birth time (use 24-hr time)","Tell me your birth time","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v6.getObject())));
 }else {
 //BA.debugLineNum = 289;BA.debugLine="dd.Year = DateTime.GetYear(DateTime.Now)";
_dd.setYear(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 290;BA.debugLine="dd.Month = DateTime.GetMonth(DateTime.Now)";
_dd.setMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 291;BA.debugLine="dd.DayOfMonth = DateTime.GetDayOfMonth(DateTime.Now)";
_dd.setDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 293;BA.debugLine="ret = dd.Show(\"Set your birth date\", \"Tell me your birth date\", \"OK\", \"\", \"\", Bmp1)";
_ret = BA.NumberToString(_dd.Show("Set your birth date","Tell me your birth date","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v5.getObject())));
 //BA.debugLineNum = 296;BA.debugLine="td.Hour = DateTime.GetHour(DateTime.Now)";
_td.setHour(anywheresoftware.b4a.keywords.Common.DateTime.GetHour(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 297;BA.debugLine="td.Minute = DateTime.GetMinute(DateTime.Now)";
_td.setMinute(anywheresoftware.b4a.keywords.Common.DateTime.GetMinute(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 298;BA.debugLine="td.Is24Hours = True";
_td.setIs24Hours(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 300;BA.debugLine="ret = td.Show(\"Set your birth time (use 24-hr time)\", \"Tell me your birth time\", \"OK\", \"\", \"\", Bmp2)";
_ret = BA.NumberToString(_td.Show("Set your birth time (use 24-hr time)","Tell me your birth time","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v6.getObject())));
 };
 //BA.debugLineNum = 304;BA.debugLine="M = dd.Month";
_m = _dd.getMonth();
 //BA.debugLineNum = 305;BA.debugLine="d = dd.DayOfMonth";
_d = _dd.getDayOfMonth();
 //BA.debugLineNum = 306;BA.debugLine="y = dd.Year";
_y = _dd.getYear();
 //BA.debugLineNum = 308;BA.debugLine="h = td.Hour";
_h = _td.getHour();
 //BA.debugLineNum = 309;BA.debugLine="n = td.Minute";
_n = _td.getMinute();
 //BA.debugLineNum = 311;BA.debugLine="tz = GetNatalTimeZone(tz)";
_tz = (float)(Double.parseDouble(_vv2(_tz)));
 //BA.debugLineNum = 314;BA.debugLine="List1.Initialize";
_list1.Initialize();
 //BA.debugLineNum = 316;BA.debugLine="List1.Add(M)";
_list1.Add((Object)(_m));
 //BA.debugLineNum = 317;BA.debugLine="List1.Add(d)";
_list1.Add((Object)(_d));
 //BA.debugLineNum = 318;BA.debugLine="List1.Add(y)";
_list1.Add((Object)(_y));
 //BA.debugLineNum = 320;BA.debugLine="List1.Add(h)";
_list1.Add((Object)(_h));
 //BA.debugLineNum = 321;BA.debugLine="List1.Add(n)";
_list1.Add((Object)(_n));
 //BA.debugLineNum = 323;BA.debugLine="List1.Add(tz)";
_list1.Add((Object)(_tz));
 //BA.debugLineNum = 325;BA.debugLine="File.WriteList(File.DirInternal, \"natal_data.txt\", List1)";
anywheresoftware.b4a.keywords.Common.File.WriteList(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"natal_data.txt",_list1);
 //BA.debugLineNum = 326;BA.debugLine="End Sub";
return "";
}
public static String  _btndate_click() throws Exception{
anywheresoftware.b4a.agraham.dialogs.InputDialog.DateDialog _dd = null;
anywheresoftware.b4a.agraham.dialogs.InputDialog.TimeDialog _td = null;
float _tod = 0f;
double _da = 0;
double _jd = 0;
int _m = 0;
int _d = 0;
int _y = 0;
int _h = 0;
int _n = 0;
anywheresoftware.b4a.objects.collections.List _list1 = null;
String _ret = "";
String _tz = "";
String _natal_date = "";
String _natal_time = "";
int _i = 0;
 //BA.debugLineNum = 135;BA.debugLine="Sub btnDate_Click";
 //BA.debugLineNum = 136;BA.debugLine="Dim dd As DateDialog";
_dd = new anywheresoftware.b4a.agraham.dialogs.InputDialog.DateDialog();
 //BA.debugLineNum = 137;BA.debugLine="Dim td As TimeDialog";
_td = new anywheresoftware.b4a.agraham.dialogs.InputDialog.TimeDialog();
 //BA.debugLineNum = 138;BA.debugLine="Dim tod As Float";
_tod = 0f;
 //BA.debugLineNum = 139;BA.debugLine="Dim da, JD As Double";
_da = 0;
_jd = 0;
 //BA.debugLineNum = 140;BA.debugLine="Dim M, d, y, h, n As Int";
_m = 0;
_d = 0;
_y = 0;
_h = 0;
_n = 0;
 //BA.debugLineNum = 141;BA.debugLine="Dim List1 As List";
_list1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 143;BA.debugLine="EditText1.Visible = True";
mostCurrent._edittext1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 147;BA.debugLine="If File.Exists(File.DirInternal, \"natal_data.txt\") = False Then";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"natal_data.txt")==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 149;BA.debugLine="dd.Year = DateTime.GetYear(DateTime.Now)";
_dd.setYear(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 150;BA.debugLine="dd.Month = DateTime.GetMonth(DateTime.Now)";
_dd.setMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 151;BA.debugLine="dd.DayOfMonth = DateTime.GetDayOfMonth(DateTime.Now)";
_dd.setDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 153;BA.debugLine="ret = dd.Show(\"Set your birth date\", \"Tell me your birth date\", \"OK\", \"\", \"\", Bmp1)";
_ret = BA.NumberToString(_dd.Show("Set your birth date","Tell me your birth date","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v5.getObject())));
 //BA.debugLineNum = 156;BA.debugLine="td.Hour = DateTime.GetHour(DateTime.Now)";
_td.setHour(anywheresoftware.b4a.keywords.Common.DateTime.GetHour(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 157;BA.debugLine="td.Minute = DateTime.GetMinute(DateTime.Now)";
_td.setMinute(anywheresoftware.b4a.keywords.Common.DateTime.GetMinute(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 158;BA.debugLine="td.Is24Hours = True";
_td.setIs24Hours(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 160;BA.debugLine="ret = td.Show(\"Set your birth time (use 24-hr time)\", \"Tell me your birth time\", \"OK\", \"\", \"\", Bmp2)";
_ret = BA.NumberToString(_td.Show("Set your birth time (use 24-hr time)","Tell me your birth time","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v6.getObject())));
 //BA.debugLineNum = 163;BA.debugLine="M = dd.Month";
_m = _dd.getMonth();
 //BA.debugLineNum = 164;BA.debugLine="d = dd.DayOfMonth";
_d = _dd.getDayOfMonth();
 //BA.debugLineNum = 165;BA.debugLine="y = dd.Year";
_y = _dd.getYear();
 //BA.debugLineNum = 167;BA.debugLine="h = td.Hour";
_h = _td.getHour();
 //BA.debugLineNum = 168;BA.debugLine="n = td.Minute";
_n = _td.getMinute();
 //BA.debugLineNum = 170;BA.debugLine="tz = GetNatalTimeZone(0)";
_tz = _vv2((float)(0));
 //BA.debugLineNum = 173;BA.debugLine="List1.Initialize";
_list1.Initialize();
 //BA.debugLineNum = 175;BA.debugLine="List1.Add(M)";
_list1.Add((Object)(_m));
 //BA.debugLineNum = 176;BA.debugLine="List1.Add(d)";
_list1.Add((Object)(_d));
 //BA.debugLineNum = 177;BA.debugLine="List1.Add(y)";
_list1.Add((Object)(_y));
 //BA.debugLineNum = 179;BA.debugLine="List1.Add(h)";
_list1.Add((Object)(_h));
 //BA.debugLineNum = 180;BA.debugLine="List1.Add(n)";
_list1.Add((Object)(_n));
 //BA.debugLineNum = 181;BA.debugLine="List1.Add(tz)";
_list1.Add((Object)(_tz));
 //BA.debugLineNum = 183;BA.debugLine="File.WriteList(File.DirInternal, \"natal_data.txt\", List1)";
anywheresoftware.b4a.keywords.Common.File.WriteList(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"natal_data.txt",_list1);
 }else {
 //BA.debugLineNum = 187;BA.debugLine="List1 = File.ReadList(File.DirInternal, \"natal_data.txt\")";
_list1 = anywheresoftware.b4a.keywords.Common.File.ReadList(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"natal_data.txt");
 //BA.debugLineNum = 189;BA.debugLine="M = List1.Get(0)";
_m = (int)(BA.ObjectToNumber(_list1.Get((int)(0))));
 //BA.debugLineNum = 190;BA.debugLine="d = List1.Get(1)";
_d = (int)(BA.ObjectToNumber(_list1.Get((int)(1))));
 //BA.debugLineNum = 191;BA.debugLine="y = List1.Get(2)";
_y = (int)(BA.ObjectToNumber(_list1.Get((int)(2))));
 //BA.debugLineNum = 193;BA.debugLine="h = List1.Get(3)";
_h = (int)(BA.ObjectToNumber(_list1.Get((int)(3))));
 //BA.debugLineNum = 194;BA.debugLine="n = List1.Get(4)";
_n = (int)(BA.ObjectToNumber(_list1.Get((int)(4))));
 //BA.debugLineNum = 196;BA.debugLine="tz = List1.Get(5)";
_tz = String.valueOf(_list1.Get((int)(5)));
 };
 //BA.debugLineNum = 199;BA.debugLine="tod = h + n / 60";
_tod = (float)(_h+_n/(double)60);
 //BA.debugLineNum = 201;BA.debugLine="JD = swe0.getJulDay(y, M, d, tod)";
_jd = _vv3.getJulDay(_y,_m,_d,_tod);
 //BA.debugLineNum = 202;BA.debugLine="JD = JD - (tz / 24)";
_jd = _jd-((double)(Double.parseDouble(_tz))/(double)24);
 //BA.debugLineNum = 205;BA.debugLine="EditText1.InputType = EditText1.INPUT_TYPE_NONE				'do not allow software keypad to appear";
mostCurrent._edittext1.setInputType(mostCurrent._edittext1.INPUT_TYPE_NONE);
 //BA.debugLineNum = 206;BA.debugLine="EditText1.SingleLine = False													'necessary";
mostCurrent._edittext1.setSingleLine(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 207;BA.debugLine="EditText1.Wrap = True";
mostCurrent._edittext1.setWrap(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 208;BA.debugLine="EditText1.Text = \"\"";
mostCurrent._edittext1.setText((Object)(""));
 //BA.debugLineNum = 210;BA.debugLine="natal_date = NumberFormat(d, 2, 0) & \" \" & month_names(M) & \" \" & y";
_natal_date = anywheresoftware.b4a.keywords.Common.NumberFormat(_d,(int)(2),(int)(0))+" "+_month_names[_m]+" "+BA.NumberToString(_y);
 //BA.debugLineNum = 211;BA.debugLine="natal_time = h & \":\" & NumberFormat(n, 2, 0)";
_natal_time = BA.NumberToString(_h)+":"+anywheresoftware.b4a.keywords.Common.NumberFormat(_n,(int)(2),(int)(0));
 //BA.debugLineNum = 213;BA.debugLine="natal_data_header = \"   Natal date - \" & natal_date & \" at \" & natal_time & \" (tz=\" & tz & \")\"";
_natal_data_header = "   Natal date - "+_natal_date+" at "+_natal_time+" (tz="+_tz+")";
 //BA.debugLineNum = 216;BA.debugLine="natal_data = \"\"";
_natal_data = "";
 //BA.debugLineNum = 217;BA.debugLine="For i = 0 To 9";
{
final double step148 = 1;
final double limit148 = (int)(9);
for (_i = (int)(0); (step148 > 0 && _i <= limit148) || (step148 < 0 && _i >= limit148); _i += step148) {
 //BA.debugLineNum = 218;BA.debugLine="Natal(i) = Get_1_Planet(JD, i)";
_vv4[_i] = _get_1_planet(_jd,_i);
 //BA.debugLineNum = 220;BA.debugLine="natal_data = natal_data & p_names(i) & \" = \" & Convert_Longitude(Natal(i)) & \"   -   \" & NumberFormat2(Natal(i), 1, 4, 4, False) & CRLF";
_natal_data = _natal_data+_p_names[_i]+" = "+_convert_longitude((float)(_vv4[_i]))+"   -   "+anywheresoftware.b4a.keywords.Common.NumberFormat2(_vv4[_i],(int)(1),(int)(4),(int)(4),anywheresoftware.b4a.keywords.Common.False)+anywheresoftware.b4a.keywords.Common.CRLF;
 }
};
 //BA.debugLineNum = 225;BA.debugLine="dd.Year = DateTime.GetYear(DateTime.Now)";
_dd.setYear(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 226;BA.debugLine="dd.Month = DateTime.GetMonth(DateTime.Now)";
_dd.setMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 227;BA.debugLine="dd.DayOfMonth = DateTime.GetDayOfMonth(DateTime.Now)";
_dd.setDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 229;BA.debugLine="ret = dd.Show(\"Set the transit date\", \"What transit date do you want?\", \"OK\", \"\", \"\", Bmp1)";
_ret = BA.NumberToString(_dd.Show("Set the transit date","What transit date do you want?","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v5.getObject())));
 //BA.debugLineNum = 231;BA.debugLine="td.Hour = DateTime.GetHour(DateTime.Now)";
_td.setHour(anywheresoftware.b4a.keywords.Common.DateTime.GetHour(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 232;BA.debugLine="td.Minute = DateTime.GetMinute(DateTime.Now)";
_td.setMinute(anywheresoftware.b4a.keywords.Common.DateTime.GetMinute(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 233;BA.debugLine="td.Is24Hours = True";
_td.setIs24Hours(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 235;BA.debugLine="ret = td.Show(\"Set the transit time (use 24-hr time)\", \"What transit time do you want to use?\", \"OK\", \"\", \"\", Bmp2)";
_ret = BA.NumberToString(_td.Show("Set the transit time (use 24-hr time)","What transit time do you want to use?","OK","","",mostCurrent.activityBA,(android.graphics.Bitmap)(mostCurrent._v6.getObject())));
 //BA.debugLineNum = 238;BA.debugLine="tz_offset = GetTimeZoneOffset							'PST = -8, for instance";
_tz_offset = (float)(Double.parseDouble(_vv5()));
 //BA.debugLineNum = 240;BA.debugLine="tod = td.Hour + td.Minute / 60";
_tod = (float)(_td.getHour()+_td.getMinute()/(double)60);
 //BA.debugLineNum = 242;BA.debugLine="JD = swe0.getJulDay(dd.Year, dd.Month, dd.DayOfMonth, tod)";
_jd = _vv3.getJulDay(_dd.getYear(),_dd.getMonth(),_dd.getDayOfMonth(),_tod);
 //BA.debugLineNum = 243;BA.debugLine="JD = JD - (tz_offset / 24)";
_jd = _jd-(_tz_offset/(double)24);
 //BA.debugLineNum = 244;BA.debugLine="current_JD = JD														'for use with Previous ans Next buttons";
_current_jd = _jd;
 //BA.debugLineNum = 246;BA.debugLine="Get_transit_interps_for_this_day(current_JD)";
_get_transit_interps_for_this_day(_current_jd);
 //BA.debugLineNum = 248;BA.debugLine="btnPrevious.Enabled = True";
mostCurrent._btnprevious.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 249;BA.debugLine="btnNext.Enabled = True";
mostCurrent._btnnext.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 250;BA.debugLine="btnWheel_Text.Enabled = True";
mostCurrent._btnwheel_text.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 251;BA.debugLine="btnWheel_Text.Text = \"Wheel\"";
mostCurrent._btnwheel_text.setText((Object)("Wheel"));
 //BA.debugLineNum = 252;BA.debugLine="End Sub";
return "";
}
public static String  _btnhelp_click() throws Exception{
 //BA.debugLineNum = 666;BA.debugLine="Sub btnHelp_Click";
 //BA.debugLineNum = 668;BA.debugLine="EditText1.Visible = True";
mostCurrent._edittext1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 669;BA.debugLine="btnWheel_Text.Text = \"Wheel\"";
mostCurrent._btnwheel_text.setText((Object)("Wheel"));
 //BA.debugLineNum = 671;BA.debugLine="If flag_help = 0 Then";
if (_flag_help==0) { 
 //BA.debugLineNum = 672;BA.debugLine="flag_help = 1";
_flag_help = (int)(1);
 //BA.debugLineNum = 673;BA.debugLine="prev_text = EditText1.Text";
_prev_text = mostCurrent._edittext1.getText();
 }else {
 //BA.debugLineNum = 675;BA.debugLine="flag_help = 0";
_flag_help = (int)(0);
 };
 //BA.debugLineNum = 678;BA.debugLine="If flag_help = 1 Then";
if (_flag_help==1) { 
 //BA.debugLineNum = 679;BA.debugLine="If File.Exists(File.DirAssets, \"help.txt\") = True Then";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"help.txt")==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 680;BA.debugLine="EditText1.Text = File.ReadString(File.DirAssets, \"help.txt\")";
mostCurrent._edittext1.setText((Object)(anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"help.txt")));
 //BA.debugLineNum = 681;BA.debugLine="btnPrevious.Enabled = False";
mostCurrent._btnprevious.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 682;BA.debugLine="btnNext.Enabled = False";
mostCurrent._btnnext.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 }else {
 //BA.debugLineNum = 685;BA.debugLine="EditText1.Text = prev_text";
mostCurrent._edittext1.setText((Object)(_prev_text));
 //BA.debugLineNum = 686;BA.debugLine="btnPrevious.Enabled = True";
mostCurrent._btnprevious.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 687;BA.debugLine="btnNext.Enabled = True";
mostCurrent._btnnext.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 689;BA.debugLine="End Sub";
return "";
}
public static String  _btnnext_click() throws Exception{
 //BA.debugLineNum = 124;BA.debugLine="Sub btnNext_Click";
 //BA.debugLineNum = 125;BA.debugLine="If current_JD = 0 Then Return";
if (_current_jd==0) { 
if (true) return "";};
 //BA.debugLineNum = 127;BA.debugLine="current_JD = current_JD + 1";
_current_jd = _current_jd+1;
 //BA.debugLineNum = 129;BA.debugLine="Get_transit_interps_for_this_day(current_JD)";
_get_transit_interps_for_this_day(_current_jd);
 //BA.debugLineNum = 132;BA.debugLine="If btnWheel_Text.Text = \"Text\" Then Display_Wheel";
if ((mostCurrent._btnwheel_text.getText()).equals("Text")) { 
_display_wheel();};
 //BA.debugLineNum = 133;BA.debugLine="End Sub";
return "";
}
public static String  _btnprevious_click() throws Exception{
 //BA.debugLineNum = 113;BA.debugLine="Sub btnPrevious_Click";
 //BA.debugLineNum = 114;BA.debugLine="If current_JD = 0 Then Return";
if (_current_jd==0) { 
if (true) return "";};
 //BA.debugLineNum = 116;BA.debugLine="current_JD = current_JD - 1";
_current_jd = _current_jd-1;
 //BA.debugLineNum = 118;BA.debugLine="Get_transit_interps_for_this_day(current_JD)";
_get_transit_interps_for_this_day(_current_jd);
 //BA.debugLineNum = 121;BA.debugLine="If btnWheel_Text.Text = \"Text\" Then Display_Wheel";
if ((mostCurrent._btnwheel_text.getText()).equals("Text")) { 
_display_wheel();};
 //BA.debugLineNum = 122;BA.debugLine="End Sub";
return "";
}
public static String  _btnwheel_text_click() throws Exception{
 //BA.debugLineNum = 328;BA.debugLine="Sub btnWheel_Text_Click";
 //BA.debugLineNum = 329;BA.debugLine="If btnWheel_Text.Text = \"Wheel\" Then";
if ((mostCurrent._btnwheel_text.getText()).equals("Wheel")) { 
 //BA.debugLineNum = 330;BA.debugLine="EditText1.Visible = False					'switch to viewing the wheel";
mostCurrent._edittext1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 331;BA.debugLine="btnWheel_Text.Text = \"Text\"";
mostCurrent._btnwheel_text.setText((Object)("Text"));
 //BA.debugLineNum = 332;BA.debugLine="Display_Wheel";
_display_wheel();
 }else {
 //BA.debugLineNum = 334;BA.debugLine="EditText1.Visible = True				  'switch to viewing the text";
mostCurrent._edittext1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 335;BA.debugLine="btnWheel_Text.Text = \"Wheel\"";
mostCurrent._btnwheel_text.setText((Object)("Wheel"));
 };
 //BA.debugLineNum = 337;BA.debugLine="End Sub";
return "";
}
public static boolean  _check_for_overlap(float _angle,int _spacing) throws Exception{
boolean _result = false;
int _i = 0;
 //BA.debugLineNum = 1056;BA.debugLine="Sub Check_for_overlap(angle As Float, spacing As Int) As Boolean";
 //BA.debugLineNum = 1057;BA.debugLine="Dim result As Boolean";
_result = false;
 //BA.debugLineNum = 1060;BA.debugLine="result = False";
_result = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 1062;BA.debugLine="For i = angle - spacing To angle + spacing";
{
final double step703 = 1;
final double limit703 = (int)(_angle+_spacing);
for (_i = (int)(_angle-_spacing); (step703 > 0 && _i <= limit703) || (step703 < 0 && _i >= limit703); _i += step703) {
 //BA.debugLineNum = 1063;BA.debugLine="If spot_filled(crunch(Round(i))) = 1 Then";
if (_spot_filled[(int)(_vv6(anywheresoftware.b4a.keywords.Common.Round(_i)))]==1) { 
 //BA.debugLineNum = 1064;BA.debugLine="result = True";
_result = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 1066;BA.debugLine="Exit";
if (true) break;
 };
 }
};
 //BA.debugLineNum = 1070;BA.debugLine="Return result";
if (true) return _result;
 //BA.debugLineNum = 1071;BA.debugLine="End Sub";
return false;
}
public static String  _convert_longitude(float _longitude) throws Exception{
String[] _signs = null;
int _deg = 0;
int _mn = 0;
int _sign_num = 0;
float _full_mn = 0f;
float _pos_in_sign = 0f;
String _full_sec = "";
 //BA.debugLineNum = 1073;BA.debugLine="Sub Convert_Longitude(longitude As Float) As String";
 //BA.debugLineNum = 1074;BA.debugLine="Dim signs(12) As String";
_signs = new String[(int)(12)];
java.util.Arrays.fill(_signs,"");
 //BA.debugLineNum = 1075;BA.debugLine="Dim deg, mn, sign_num As Int";
_deg = 0;
_mn = 0;
_sign_num = 0;
 //BA.debugLineNum = 1076;BA.debugLine="Dim full_mn, pos_in_sign As Float";
_full_mn = 0f;
_pos_in_sign = 0f;
 //BA.debugLineNum = 1078;BA.debugLine="signs(0) = \"Ari\"";
_signs[(int)(0)] = "Ari";
 //BA.debugLineNum = 1079;BA.debugLine="signs(1) = \"Tau\"";
_signs[(int)(1)] = "Tau";
 //BA.debugLineNum = 1080;BA.debugLine="signs(2) = \"Gem\"";
_signs[(int)(2)] = "Gem";
 //BA.debugLineNum = 1081;BA.debugLine="signs(3) = \"Can\"";
_signs[(int)(3)] = "Can";
 //BA.debugLineNum = 1082;BA.debugLine="signs(4) = \"Leo\"";
_signs[(int)(4)] = "Leo";
 //BA.debugLineNum = 1083;BA.debugLine="signs(5) = \"Vir\"";
_signs[(int)(5)] = "Vir";
 //BA.debugLineNum = 1084;BA.debugLine="signs(6) = \"Lib\"";
_signs[(int)(6)] = "Lib";
 //BA.debugLineNum = 1085;BA.debugLine="signs(7) = \"Sco\"";
_signs[(int)(7)] = "Sco";
 //BA.debugLineNum = 1086;BA.debugLine="signs(8) = \"Sag\"";
_signs[(int)(8)] = "Sag";
 //BA.debugLineNum = 1087;BA.debugLine="signs(9) = \"Cap\"";
_signs[(int)(9)] = "Cap";
 //BA.debugLineNum = 1088;BA.debugLine="signs(10) = \"Aqu\"";
_signs[(int)(10)] = "Aqu";
 //BA.debugLineNum = 1089;BA.debugLine="signs(11) = \"Pis\"";
_signs[(int)(11)] = "Pis";
 //BA.debugLineNum = 1091;BA.debugLine="sign_num = Floor(longitude / 30)";
_sign_num = (int)(anywheresoftware.b4a.keywords.Common.Floor(_longitude/(double)30));
 //BA.debugLineNum = 1092;BA.debugLine="pos_in_sign = longitude - (sign_num * 30)";
_pos_in_sign = (float)(_longitude-(_sign_num*30));
 //BA.debugLineNum = 1093;BA.debugLine="deg = Floor(pos_in_sign)";
_deg = (int)(anywheresoftware.b4a.keywords.Common.Floor(_pos_in_sign));
 //BA.debugLineNum = 1094;BA.debugLine="full_mn = (pos_in_sign - deg) * 60";
_full_mn = (float)((_pos_in_sign-_deg)*60);
 //BA.debugLineNum = 1095;BA.debugLine="mn = Floor(full_mn)";
_mn = (int)(anywheresoftware.b4a.keywords.Common.Floor(_full_mn));
 //BA.debugLineNum = 1096;BA.debugLine="full_sec = Round((full_mn - mn) * 60)";
_full_sec = BA.NumberToString(anywheresoftware.b4a.keywords.Common.Round((_full_mn-_mn)*60));
 //BA.debugLineNum = 1098;BA.debugLine="Return NumberFormat(deg, 2, 0) & \" \" & signs(sign_num) & \" \" & NumberFormat(mn, 2, 0) & \"'\"";
if (true) return anywheresoftware.b4a.keywords.Common.NumberFormat(_deg,(int)(2),(int)(0))+" "+_signs[_sign_num]+" "+anywheresoftware.b4a.keywords.Common.NumberFormat(_mn,(int)(2),(int)(0))+"'";
 //BA.debugLineNum = 1099;BA.debugLine="End Sub";
return "";
}
public static String  _vv7(double _jdx) throws Exception{
double _fraction = 0;
double _hh = 0;
double _jd_to_use = 0;
double _mm = 0;
String _dt_string = "";
 //BA.debugLineNum = 970;BA.debugLine="Sub ConvertJDtoDateandTime(jdx As Double)";
 //BA.debugLineNum = 972;BA.debugLine="Dim fraction, hh, jd_to_use, mm As Double";
_fraction = 0;
_hh = 0;
_jd_to_use = 0;
_mm = 0;
 //BA.debugLineNum = 973;BA.debugLine="Dim dt_string As String";
_dt_string = "";
 //BA.debugLineNum = 975;BA.debugLine="jd_to_use = jdx + tz_offset / 24				'we want to get local time on the device";
_jd_to_use = _jdx+_tz_offset/(double)24;
 //BA.debugLineNum = 977;BA.debugLine="dt_string = GetCalendarDate(jd_to_use)";
_dt_string = _vv0(_jd_to_use);
 //BA.debugLineNum = 979;BA.debugLine="fraction = jd_to_use - Floor(jd_to_use)";
_fraction = _jd_to_use-anywheresoftware.b4a.keywords.Common.Floor(_jd_to_use);
 //BA.debugLineNum = 981;BA.debugLine="If (fraction < 0.5) Then";
if ((_fraction<0.5)) { 
 //BA.debugLineNum = 982;BA.debugLine="fraction = fraction + 0.5";
_fraction = _fraction+0.5;
 }else {
 //BA.debugLineNum = 984;BA.debugLine="fraction = fraction - 0.5";
_fraction = _fraction-0.5;
 };
 //BA.debugLineNum = 987;BA.debugLine="hh = fraction * 24";
_hh = _fraction*24;
 //BA.debugLineNum = 988;BA.debugLine="mm = hh - Floor(hh)";
_mm = _hh-anywheresoftware.b4a.keywords.Common.Floor(_hh);
 //BA.debugLineNum = 990;BA.debugLine="Return \"Transit date - \" & dt_string & \" at \" & NumberFormat(Floor(hh), 2, 0) & \":\" & NumberFormat(mm * 60, 2, 0) & \" (tz=\" & NumberFormat2(tz_offset, 1, 1, 1, False) & \")\"";
if (true) return "Transit date - "+_dt_string+" at "+anywheresoftware.b4a.keywords.Common.NumberFormat(anywheresoftware.b4a.keywords.Common.Floor(_hh),(int)(2),(int)(0))+":"+anywheresoftware.b4a.keywords.Common.NumberFormat(_mm*60,(int)(2),(int)(0))+" (tz="+anywheresoftware.b4a.keywords.Common.NumberFormat2(_tz_offset,(int)(1),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.False)+")";
 //BA.debugLineNum = 991;BA.debugLine="End Sub";
return "";
}
public static double  _vv6(double _x) throws Exception{
 //BA.debugLineNum = 1013;BA.debugLine="Sub crunch(x As Double) As Double";
 //BA.debugLineNum = 1014;BA.debugLine="If x >= 360 Then";
if (_x>=360) { 
 //BA.debugLineNum = 1015;BA.debugLine="Return x - 360";
if (true) return _x-360;
 }else if(_x<0) { 
 //BA.debugLineNum = 1017;BA.debugLine="Return x + 360";
if (true) return _x+360;
 }else {
 //BA.debugLineNum = 1019;BA.debugLine="Return x";
if (true) return _x;
 };
 //BA.debugLineNum = 1021;BA.debugLine="End Sub";
return 0;
}
public static float[]  _display_planet_glyph(float _our_angle,float _angle_to_use,int _radii) throws Exception{
int _ch_pl_glyph = 0;
int _cw_pl_glyph = 0;
int _gap_pl_glyph = 0;
float _center_pos_x = 0f;
float _center_pos_y = 0f;
float _offset_pos_x = 0f;
float _offset_pos_y = 0f;
float _this_angle = 0f;
float[] _xy = null;
 //BA.debugLineNum = 1023;BA.debugLine="Sub display_planet_glyph(our_angle As Float, angle_to_use As Float, radii As Int) As Float()";
 //BA.debugLineNum = 1024;BA.debugLine="Dim ch_pl_glyph, cw_pl_glyph, gap_pl_glyph As Int";
_ch_pl_glyph = 0;
_cw_pl_glyph = 0;
_gap_pl_glyph = 0;
 //BA.debugLineNum = 1025;BA.debugLine="Dim center_pos_x, center_pos_y, offset_pos_x, offset_pos_y, this_angle, xy(2) As Float";
_center_pos_x = 0f;
_center_pos_y = 0f;
_offset_pos_x = 0f;
_offset_pos_y = 0f;
_this_angle = 0f;
_xy = new float[(int)(2)];
;
 //BA.debugLineNum = 1028;BA.debugLine="this_angle = crunch(our_angle)";
_this_angle = (float)(_vv6(_our_angle));
 //BA.debugLineNum = 1030;BA.debugLine="If this_angle >= 1 AND this_angle <= 181 Then";
if (_this_angle>=1 && _this_angle<=181) { 
 //BA.debugLineNum = 1031;BA.debugLine="cw_pl_glyph = 32";
_cw_pl_glyph = (int)(32);
 //BA.debugLineNum = 1032;BA.debugLine="ch_pl_glyph = 32";
_ch_pl_glyph = (int)(32);
 //BA.debugLineNum = 1033;BA.debugLine="gap_pl_glyph = -10";
_gap_pl_glyph = (int)(-10);
 }else {
 //BA.debugLineNum = 1035;BA.debugLine="cw_pl_glyph = 28";
_cw_pl_glyph = (int)(28);
 //BA.debugLineNum = 1036;BA.debugLine="ch_pl_glyph = 32";
_ch_pl_glyph = (int)(32);
 //BA.debugLineNum = 1037;BA.debugLine="gap_pl_glyph = -14";
_gap_pl_glyph = (int)(-14);
 };
 //BA.debugLineNum = 1042;BA.debugLine="center_pos_x = -cw_pl_glyph / 2";
_center_pos_x = (float)(-_cw_pl_glyph/(double)2);
 //BA.debugLineNum = 1043;BA.debugLine="center_pos_y = ch_pl_glyph / 2";
_center_pos_y = (float)(_ch_pl_glyph/(double)2);
 //BA.debugLineNum = 1046;BA.debugLine="offset_pos_x = center_pos_x * Cos(angle_to_use)";
_offset_pos_x = (float)(_center_pos_x*anywheresoftware.b4a.keywords.Common.Cos(_angle_to_use));
 //BA.debugLineNum = 1047;BA.debugLine="offset_pos_y = center_pos_y * Sin(angle_to_use)";
_offset_pos_y = (float)(_center_pos_y*anywheresoftware.b4a.keywords.Common.Sin(_angle_to_use));
 //BA.debugLineNum = 1050;BA.debugLine="xy(0) = center_pos_x + offset_pos_x + ((-radii + gap_pl_glyph) * Cos(angle_to_use))";
_xy[(int)(0)] = (float)(_center_pos_x+_offset_pos_x+((-_radii+_gap_pl_glyph)*anywheresoftware.b4a.keywords.Common.Cos(_angle_to_use)));
 //BA.debugLineNum = 1051;BA.debugLine="xy(1) = center_pos_y + offset_pos_y + ((radii - gap_pl_glyph) * Sin(angle_to_use))";
_xy[(int)(1)] = (float)(_center_pos_y+_offset_pos_y+((_radii-_gap_pl_glyph)*anywheresoftware.b4a.keywords.Common.Sin(_angle_to_use)));
 //BA.debugLineNum = 1053;BA.debugLine="Return xy";
if (true) return _xy;
 //BA.debugLineNum = 1054;BA.debugLine="End Sub";
return null;
}
public static String  _display_wheel() throws Exception{
int _center_pt_x = 0;
int _center_pt_y = 0;
int _cw_sign_glyph = 0;
int _ch_sign_glyph = 0;
int _gap_sign_glyph = 0;
int _i = 0;
int _inner_radius = 0;
int _j = 0;
int[] _nopih = null;
int _radius = 0;
int[] _sort_pos = null;
int _temp1 = 0;
int _cnt = 0;
int _house_num = 0;
int _house_of_pl = 0;
int _how_many_more_can_fit_in_this_house = 0;
int _pl_num = 0;
int _planets_done = 0;
int[] _sp = null;
int _spacing = 0;
int _start_planet = 0;
int _start_planet_idx = 0;
int _ah = 0;
int _aw = 0;
int _offset_distance = 0;
int[][] _planet_angle = null;
int _q = 0;
float _angle_to_use = 0f;
float _center_pos_x = 0f;
float _center_pos_y = 0f;
float _da = 0f;
float _offset_pos_x = 0f;
float _offset_pos_y = 0f;
float _x1 = 0f;
float _x2 = 0f;
float[] _xy = null;
float _y1 = 0f;
float _y2 = 0f;
double _angle = 0;
double _from_cusp = 0;
double _to_next_cusp = 0;
double _next_cusp = 0;
double _our_angle = 0;
double[] _s = null;
double[] _sort = null;
double _temp = 0;
int _kk = 0;
 //BA.debugLineNum = 339;BA.debugLine="Sub Display_Wheel";
 //BA.debugLineNum = 340;BA.debugLine="Dim center_pt_x, center_pt_y, cw_sign_glyph, ch_sign_glyph, gap_sign_glyph, i, inner_radius, j, nopih(13), radius, sort_pos(10), temp1 As Int";
_center_pt_x = 0;
_center_pt_y = 0;
_cw_sign_glyph = 0;
_ch_sign_glyph = 0;
_gap_sign_glyph = 0;
_i = 0;
_inner_radius = 0;
_j = 0;
_nopih = new int[(int)(13)];
;
_radius = 0;
_sort_pos = new int[(int)(10)];
;
_temp1 = 0;
 //BA.debugLineNum = 341;BA.debugLine="Dim cnt, house_num, house_of_pl, how_many_more_can_fit_in_this_house, pl_num, planets_done, sp(10), spacing, start_planet, start_planet_idx As Int";
_cnt = 0;
_house_num = 0;
_house_of_pl = 0;
_how_many_more_can_fit_in_this_house = 0;
_pl_num = 0;
_planets_done = 0;
_sp = new int[(int)(10)];
;
_spacing = 0;
_start_planet = 0;
_start_planet_idx = 0;
 //BA.debugLineNum = 342;BA.debugLine="Dim ah, aw, offset_distance, planet_angle(2, 10), q As Int";
_ah = 0;
_aw = 0;
_offset_distance = 0;
_planet_angle = new int[(int)(2)][];
{
int d0 = _planet_angle.length;
int d1 = (int)(10);
for (int i0 = 0;i0 < d0;i0++) {
_planet_angle[i0] = new int[d1];
}
}
;
_q = 0;
 //BA.debugLineNum = 343;BA.debugLine="Dim angle_to_use, center_pos_x, center_pos_y, da, offset_pos_x, offset_pos_y, x1, x2, xy(2), y1, y2 As Float";
_angle_to_use = 0f;
_center_pos_x = 0f;
_center_pos_y = 0f;
_da = 0f;
_offset_pos_x = 0f;
_offset_pos_y = 0f;
_x1 = 0f;
_x2 = 0f;
_xy = new float[(int)(2)];
;
_y1 = 0f;
_y2 = 0f;
 //BA.debugLineNum = 344;BA.debugLine="Dim angle, from_cusp, to_next_cusp, next_cusp, our_angle, s(10), sort(10), temp As Double";
_angle = 0;
_from_cusp = 0;
_to_next_cusp = 0;
_next_cusp = 0;
_our_angle = 0;
_s = new double[(int)(10)];
;
_sort = new double[(int)(10)];
;
_temp = 0;
 //BA.debugLineNum = 346;BA.debugLine="ah = Activity.Height";
_ah = mostCurrent._activity.getHeight();
 //BA.debugLineNum = 347;BA.debugLine="aw = Activity.Width";
_aw = mostCurrent._activity.getWidth();
 //BA.debugLineNum = 348;BA.debugLine="If aw > ah OR ah = 0 OR aw = 0 Then";
if (_aw>_ah || _ah==0 || _aw==0) { 
 //BA.debugLineNum = 349;BA.debugLine="cvsLayer.DrawText(\"The wheel is not viewable in landscape mode.\", 50, 104, Typeface.DEFAULT, 18, Colors.White, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,"The wheel is not viewable in landscape mode.",(float)(50),(float)(104),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(18),anywheresoftware.b4a.keywords.Common.Colors.White,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 350;BA.debugLine="Return			'do not allow if in landscape mode";
if (true) return "";
 };
 //BA.debugLineNum = 353;BA.debugLine="If Natal(0) = 0 AND Natal(1) = 0 AND Transit(0) = 0 AND Transit(1) = 0 AND Natal(9) = 0 AND Transit(9) = 0 Then Return";
if (_vv4[(int)(0)]==0 && _vv4[(int)(1)]==0 && _vvv1[(int)(0)]==0 && _vvv1[(int)(1)]==0 && _vv4[(int)(9)]==0 && _vvv1[(int)(9)]==0) { 
if (true) return "";};
 //BA.debugLineNum = 355;BA.debugLine="spacing = 4";
_spacing = (int)(4);
 //BA.debugLineNum = 367;BA.debugLine="If EditText1.Visible = False Then";
if (mostCurrent._edittext1.getVisible()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 371;BA.debugLine="cvsLayer.DrawColor(Colors.Black)				 'clear the previous panel";
mostCurrent._vv1.DrawColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 372;BA.debugLine="Activity.Invalidate                      'this is needed if you want NEXT-PREVIOUS to update the wheel";
mostCurrent._activity.Invalidate();
 //BA.debugLineNum = 375;BA.debugLine="center_pt_x = 300";
_center_pt_x = (int)(300);
 //BA.debugLineNum = 376;BA.debugLine="center_pt_y = 452";
_center_pt_y = (int)(452);
 //BA.debugLineNum = 377;BA.debugLine="radius = 250";
_radius = (int)(250);
 //BA.debugLineNum = 378;BA.debugLine="inner_radius = 50";
_inner_radius = (int)(50);
 //BA.debugLineNum = 381;BA.debugLine="cvsLayer.DrawText(transit_data_header, 50, 80, Typeface.DEFAULT, 18, Colors.White, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,_transit_data_header,(float)(50),(float)(80),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(18),anywheresoftware.b4a.keywords.Common.Colors.White,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 382;BA.debugLine="cvsLayer.DrawText(natal_data_header, 50, 104, Typeface.DEFAULT, 18, Colors.White, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,_natal_data_header,(float)(50),(float)(104),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(18),anywheresoftware.b4a.keywords.Common.Colors.White,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 385;BA.debugLine="cvsLayer.DrawText(\"Transit planets in\", 50, 850, Typeface.DEFAULT, 18, Colors.White, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,"Transit planets in",(float)(50),(float)(850),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(18),anywheresoftware.b4a.keywords.Common.Colors.White,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 386;BA.debugLine="cvsLayer.DrawText(\"Natal planets in\", 50, 874, Typeface.DEFAULT, 18, Colors.White, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,"Natal planets in",(float)(50),(float)(874),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(18),anywheresoftware.b4a.keywords.Common.Colors.White,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 388;BA.debugLine="cvsLayer.DrawText(\"magenta\", 200, 850, Typeface.DEFAULT, 18, Colors.Magenta, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,"magenta",(float)(200),(float)(850),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(18),anywheresoftware.b4a.keywords.Common.Colors.Magenta,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 389;BA.debugLine="cvsLayer.DrawText(\"cyan\", 190, 874, Typeface.DEFAULT, 18, Colors.Cyan, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,"cyan",(float)(190),(float)(874),anywheresoftware.b4a.keywords.Common.Typeface.DEFAULT,(float)(18),anywheresoftware.b4a.keywords.Common.Colors.Cyan,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 //BA.debugLineNum = 392;BA.debugLine="For i = 0 To 330 Step 30";
{
final double step256 = 30;
final double limit256 = (int)(330);
for (_i = (int)(0); (step256 > 0 && _i <= limit256) || (step256 < 0 && _i >= limit256); _i += step256) {
 //BA.debugLineNum = 393;BA.debugLine="x1 = radius * Cos(d2r * i)";
_x1 = (float)(_radius*anywheresoftware.b4a.keywords.Common.Cos(_v0*_i));
 //BA.debugLineNum = 394;BA.debugLine="y1 = radius * Sin(d2r * i)";
_y1 = (float)(_radius*anywheresoftware.b4a.keywords.Common.Sin(_v0*_i));
 //BA.debugLineNum = 396;BA.debugLine="x2 = (inner_radius) * Cos(d2r * i)";
_x2 = (float)((_inner_radius)*anywheresoftware.b4a.keywords.Common.Cos(_v0*_i));
 //BA.debugLineNum = 397;BA.debugLine="y2 = (inner_radius) * Sin(d2r * i)";
_y2 = (float)((_inner_radius)*anywheresoftware.b4a.keywords.Common.Sin(_v0*_i));
 //BA.debugLineNum = 399;BA.debugLine="cvsLayer.DrawLine(x1 + center_pt_x, y1 + center_pt_y, x2 + center_pt_x, y2 + center_pt_y, Colors.Gray, 1dip)";
mostCurrent._vv1.DrawLine((float)(_x1+_center_pt_x),(float)(_y1+_center_pt_y),(float)(_x2+_center_pt_x),(float)(_y2+_center_pt_y),anywheresoftware.b4a.keywords.Common.Colors.Gray,(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1))));
 }
};
 //BA.debugLineNum = 403;BA.debugLine="cvsLayer.DrawCircle(center_pt_x, center_pt_y, radius, Colors.White, False, 2dip)";
mostCurrent._vv1.DrawCircle((float)(_center_pt_x),(float)(_center_pt_y),(float)(_radius),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.False,(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2))));
 //BA.debugLineNum = 406;BA.debugLine="cvsLayer.DrawCircle(center_pt_x, center_pt_y, inner_radius, Colors.White, False, 2dip)";
mostCurrent._vv1.DrawCircle((float)(_center_pt_x),(float)(_center_pt_y),(float)(_inner_radius),anywheresoftware.b4a.keywords.Common.Colors.White,anywheresoftware.b4a.keywords.Common.False,(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2))));
 //BA.debugLineNum = 409;BA.debugLine="cw_sign_glyph = 28";
_cw_sign_glyph = (int)(28);
 //BA.debugLineNum = 410;BA.debugLine="ch_sign_glyph = 28";
_ch_sign_glyph = (int)(28);
 //BA.debugLineNum = 411;BA.debugLine="gap_sign_glyph = -32";
_gap_sign_glyph = (int)(-32);
 //BA.debugLineNum = 413;BA.debugLine="For i = 1 To 12";
{
final double step268 = 1;
final double limit268 = (int)(12);
for (_i = (int)(1); (step268 > 0 && _i <= limit268) || (step268 < 0 && _i >= limit268); _i += step268) {
 //BA.debugLineNum = 414;BA.debugLine="angle_to_use = d2r * (((i - 1) * 30) + 15)";
_angle_to_use = (float)(_v0*(((_i-1)*30)+15));
 //BA.debugLineNum = 416;BA.debugLine="center_pos_x = -cw_sign_glyph / 2";
_center_pos_x = (float)(-_cw_sign_glyph/(double)2);
 //BA.debugLineNum = 417;BA.debugLine="center_pos_y = ch_sign_glyph / 2";
_center_pos_y = (float)(_ch_sign_glyph/(double)2);
 //BA.debugLineNum = 419;BA.debugLine="offset_pos_x = center_pos_x * Cos(angle_to_use)";
_offset_pos_x = (float)(_center_pos_x*anywheresoftware.b4a.keywords.Common.Cos(_angle_to_use));
 //BA.debugLineNum = 420;BA.debugLine="offset_pos_y = center_pos_y * Sin(angle_to_use)";
_offset_pos_y = (float)(_center_pos_y*anywheresoftware.b4a.keywords.Common.Sin(_angle_to_use));
 //BA.debugLineNum = 422;BA.debugLine="x1 = center_pos_x + offset_pos_x + ((-radius + gap_sign_glyph) * Cos(angle_to_use))";
_x1 = (float)(_center_pos_x+_offset_pos_x+((-_radius+_gap_sign_glyph)*anywheresoftware.b4a.keywords.Common.Cos(_angle_to_use)));
 //BA.debugLineNum = 423;BA.debugLine="y1 = center_pos_y + offset_pos_y + ((radius - gap_sign_glyph) * Sin(angle_to_use))";
_y1 = (float)(_center_pos_y+_offset_pos_y+((_radius-_gap_sign_glyph)*anywheresoftware.b4a.keywords.Common.Sin(_angle_to_use)));
 //BA.debugLineNum = 425;BA.debugLine="cvsLayer.DrawText(Chr(sign_glyph(i)), x1 + center_pt_x, y1 + center_pt_y, HamburgFont, 28, Colors.Green, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,String.valueOf(anywheresoftware.b4a.keywords.Common.Chr(_sign_glyph[_i])),(float)(_x1+_center_pt_x),(float)(_y1+_center_pt_y),(android.graphics.Typeface)(mostCurrent._v7.getObject()),(float)(28),anywheresoftware.b4a.keywords.Common.Colors.Green,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 }
};
 //BA.debugLineNum = 429;BA.debugLine="For kk = 0 To 1				             'kk = 0 means natal planets, kk = 1 means transit planets";
{
final double step278 = 1;
final double limit278 = (int)(1);
for (_kk = (int)(0); (step278 > 0 && _kk <= limit278) || (step278 < 0 && _kk >= limit278); _kk += step278) {
 //BA.debugLineNum = 432;BA.debugLine="For i = 0 To 9";
{
final double step279 = 1;
final double limit279 = (int)(9);
for (_i = (int)(0); (step279 > 0 && _i <= limit279) || (step279 < 0 && _i >= limit279); _i += step279) {
 //BA.debugLineNum = 433;BA.debugLine="If kk = 0 Then";
if (_kk==0) { 
 //BA.debugLineNum = 434;BA.debugLine="sort(i) = Natal(i)";
_sort[_i] = _vv4[_i];
 }else {
 //BA.debugLineNum = 436;BA.debugLine="sort(i) = Transit(i)";
_sort[_i] = _vvv1[_i];
 };
 //BA.debugLineNum = 439;BA.debugLine="sort_pos(i) = i";
_sort_pos[_i] = _i;
 }
};
 //BA.debugLineNum = 442;BA.debugLine="For i = 0 To 8									  'do the actual sort";
{
final double step287 = 1;
final double limit287 = (int)(8);
for (_i = (int)(0); (step287 > 0 && _i <= limit287) || (step287 < 0 && _i >= limit287); _i += step287) {
 //BA.debugLineNum = 443;BA.debugLine="For j = i + 1 To 9";
{
final double step288 = 1;
final double limit288 = (int)(9);
for (_j = (int)(_i+1); (step288 > 0 && _j <= limit288) || (step288 < 0 && _j >= limit288); _j += step288) {
 //BA.debugLineNum = 444;BA.debugLine="If sort(j) > sort(i) Then";
if (_sort[_j]>_sort[_i]) { 
 //BA.debugLineNum = 445;BA.debugLine="temp = sort(i)";
_temp = _sort[_i];
 //BA.debugLineNum = 446;BA.debugLine="temp1 = sort_pos(i)";
_temp1 = _sort_pos[_i];
 //BA.debugLineNum = 448;BA.debugLine="sort(i) = sort(j)";
_sort[_i] = _sort[_j];
 //BA.debugLineNum = 449;BA.debugLine="sort_pos(i) = sort_pos(j)";
_sort_pos[_i] = _sort_pos[_j];
 //BA.debugLineNum = 451;BA.debugLine="sort(j) = temp";
_sort[_j] = _temp;
 //BA.debugLineNum = 452;BA.debugLine="sort_pos(j) = temp1";
_sort_pos[_j] = _temp1;
 };
 }
};
 }
};
 //BA.debugLineNum = 458;BA.debugLine="For i = 1 To 12								 		'count how many planets are in each house";
{
final double step299 = 1;
final double limit299 = (int)(12);
for (_i = (int)(1); (step299 > 0 && _i <= limit299) || (step299 < 0 && _i >= limit299); _i += step299) {
 //BA.debugLineNum = 459;BA.debugLine="nopih(i) = 0";
_nopih[_i] = (int)(0);
 }
};
 //BA.debugLineNum = 462;BA.debugLine="For i = 0 To 9														   'run through all the planets AND see how many planets are in each house";
{
final double step302 = 1;
final double limit302 = (int)(9);
for (_i = (int)(0); (step302 > 0 && _i <= limit302) || (step302 < 0 && _i >= limit302); _i += step302) {
 //BA.debugLineNum = 463;BA.debugLine="If kk = 0 Then";
if (_kk==0) { 
 //BA.debugLineNum = 464;BA.debugLine="temp = Floor(Natal(sort_pos(i)) / 30) + 1";
_temp = anywheresoftware.b4a.keywords.Common.Floor(_vv4[_sort_pos[_i]]/(double)30)+1;
 }else {
 //BA.debugLineNum = 466;BA.debugLine="temp = Floor(Transit(sort_pos(i)) / 30) + 1";
_temp = anywheresoftware.b4a.keywords.Common.Floor(_vvv1[_sort_pos[_i]]/(double)30)+1;
 };
 //BA.debugLineNum = 469;BA.debugLine="nopih(temp) = nopih(temp) + 1              'get house planet is in";
_nopih[(int)(_temp)] = (int)(_nopih[(int)(_temp)]+1);
 }
};
 //BA.debugLineNum = 475;BA.debugLine="For i = 8 To 0 Step -1";
{
final double step310 = -1;
final double limit310 = (int)(0);
for (_i = (int)(8); (step310 > 0 && _i <= limit310) || (step310 < 0 && _i >= limit310); _i += step310) {
 //BA.debugLineNum = 476;BA.debugLine="If sort(i) - sort(i + 1) >= 20 Then";
if (_sort[_i]-_sort[(int)(_i+1)]>=20) { 
 //BA.debugLineNum = 477;BA.debugLine="pl_num = sort_pos(i)                     'Step 2 - is this planet the first (AND only) planet in the house?";
_pl_num = _sort_pos[_i];
 //BA.debugLineNum = 479;BA.debugLine="If kk = 0 Then";
if (_kk==0) { 
 //BA.debugLineNum = 480;BA.debugLine="house_of_pl = Floor(Natal(pl_num) / 30) + 1";
_house_of_pl = (int)(anywheresoftware.b4a.keywords.Common.Floor(_vv4[_pl_num]/(double)30)+1);
 }else {
 //BA.debugLineNum = 482;BA.debugLine="house_of_pl = Floor(Transit(pl_num) / 30) + 1";
_house_of_pl = (int)(anywheresoftware.b4a.keywords.Common.Floor(_vvv1[_pl_num]/(double)30)+1);
 };
 //BA.debugLineNum = 485;BA.debugLine="If nopih(house_of_pl) = 1 Then";
if (_nopih[_house_of_pl]==1) { 
 //BA.debugLineNum = 486;BA.debugLine="start_planet = pl_num";
_start_planet = _pl_num;
 //BA.debugLineNum = 487;BA.debugLine="start_planet_idx = i";
_start_planet_idx = _i;
 //BA.debugLineNum = 489;BA.debugLine="Exit";
if (true) break;
 };
 };
 }
};
 //BA.debugLineNum = 494;BA.debugLine="If i >= 0 Then";
if (_i>=0) { 
 //BA.debugLineNum = 497;BA.debugLine="cnt = 9";
_cnt = (int)(9);
 //BA.debugLineNum = 499;BA.debugLine="For i = start_planet_idx To 0 Step -1";
{
final double step327 = -1;
final double limit327 = (int)(0);
for (_i = _start_planet_idx; (step327 > 0 && _i <= limit327) || (step327 < 0 && _i >= limit327); _i += step327) {
 //BA.debugLineNum = 500;BA.debugLine="sp(cnt) = sort_pos(i)";
_sp[_cnt] = _sort_pos[_i];
 //BA.debugLineNum = 501;BA.debugLine="s(cnt) = sort(i)";
_s[_cnt] = _sort[_i];
 //BA.debugLineNum = 502;BA.debugLine="cnt = cnt - 1";
_cnt = (int)(_cnt-1);
 }
};
 //BA.debugLineNum = 505;BA.debugLine="For i = 9 To start_planet_idx + 1 Step -1";
{
final double step332 = -1;
final double limit332 = (int)(_start_planet_idx+1);
for (_i = (int)(9); (step332 > 0 && _i <= limit332) || (step332 < 0 && _i >= limit332); _i += step332) {
 //BA.debugLineNum = 506;BA.debugLine="sp(cnt) = sort_pos(i)";
_sp[_cnt] = _sort_pos[_i];
 //BA.debugLineNum = 507;BA.debugLine="s(cnt) = sort(i)";
_s[_cnt] = _sort[_i];
 //BA.debugLineNum = 508;BA.debugLine="cnt = cnt - 1";
_cnt = (int)(_cnt-1);
 }
};
 //BA.debugLineNum = 511;BA.debugLine="For i = 0 To 9";
{
final double step337 = 1;
final double limit337 = (int)(9);
for (_i = (int)(0); (step337 > 0 && _i <= limit337) || (step337 < 0 && _i >= limit337); _i += step337) {
 //BA.debugLineNum = 512;BA.debugLine="sort_pos(i) = sp(i)";
_sort_pos[_i] = _sp[_i];
 //BA.debugLineNum = 513;BA.debugLine="sort(i) = s(i)";
_sort[_i] = _s[_i];
 }
};
 };
 //BA.debugLineNum = 518;BA.debugLine="For i = 0 To 359";
{
final double step342 = 1;
final double limit342 = (int)(359);
for (_i = (int)(0); (step342 > 0 && _i <= limit342) || (step342 < 0 && _i >= limit342); _i += step342) {
 //BA.debugLineNum = 519;BA.debugLine="spot_filled(i) = 0";
_spot_filled[_i] = (int)(0);
 }
};
 //BA.debugLineNum = 522;BA.debugLine="house_num = 0";
_house_num = (int)(0);
 //BA.debugLineNum = 525;BA.debugLine="For i = 9 To 0 Step -1";
{
final double step346 = -1;
final double limit346 = (int)(0);
for (_i = (int)(9); (step346 > 0 && _i <= limit346) || (step346 < 0 && _i >= limit346); _i += step346) {
 //BA.debugLineNum = 528;BA.debugLine="temp = house_num";
_temp = _house_num;
 //BA.debugLineNum = 530;BA.debugLine="If kk = 0 Then";
if (_kk==0) { 
 //BA.debugLineNum = 531;BA.debugLine="house_num = Floor(Natal(sort_pos(i)) / 30) + 1     'get the house this planet is in";
_house_num = (int)(anywheresoftware.b4a.keywords.Common.Floor(_vv4[_sort_pos[_i]]/(double)30)+1);
 //BA.debugLineNum = 533;BA.debugLine="offset_distance = 44";
_offset_distance = (int)(44);
 }else {
 //BA.debugLineNum = 535;BA.debugLine="house_num = Floor(Transit(sort_pos(i)) / 30) + 1";
_house_num = (int)(anywheresoftware.b4a.keywords.Common.Floor(_vvv1[_sort_pos[_i]]/(double)30)+1);
 //BA.debugLineNum = 537;BA.debugLine="offset_distance = 12";
_offset_distance = (int)(12);
 };
 //BA.debugLineNum = 540;BA.debugLine="If temp <> house_num Then planets_done = 1         'this planet is in a different house than the last one - this planet is the first one in this house, in other words";
if (_temp!=_house_num) { 
_planets_done = (int)(1);};
 //BA.debugLineNum = 543;BA.debugLine="from_cusp = crunch(sort(i) - ((house_num - 1) * 30))";
_from_cusp = _vv6(_sort[_i]-((_house_num-1)*30));
 //BA.debugLineNum = 544;BA.debugLine="to_next_cusp = crunch((house_num * 30) - sort(i))";
_to_next_cusp = _vv6((_house_num*30)-_sort[_i]);
 //BA.debugLineNum = 545;BA.debugLine="next_cusp = house_num * 30";
_next_cusp = _house_num*30;
 //BA.debugLineNum = 547;BA.debugLine="angle = sort(i)";
_angle = _sort[_i];
 //BA.debugLineNum = 548;BA.debugLine="how_many_more_can_fit_in_this_house = Floor(to_next_cusp / (spacing + 1))";
_how_many_more_can_fit_in_this_house = (int)(anywheresoftware.b4a.keywords.Common.Floor(_to_next_cusp/(double)(_spacing+1)));
 //BA.debugLineNum = 553;BA.debugLine="If nopih(house_num) - planets_done >= how_many_more_can_fit_in_this_house Then";
if (_nopih[_house_num]-_planets_done>=_how_many_more_can_fit_in_this_house) { 
 //BA.debugLineNum = 554;BA.debugLine="angle = crunch(next_cusp - ((nopih(house_num) - planets_done + 1) * (spacing + 1)))";
_angle = _vv6(_next_cusp-((_nopih[_house_num]-_planets_done+1)*(_spacing+1)));
 };
 //BA.debugLineNum = 559;BA.debugLine="Do While Check_for_overlap(angle, spacing) = True";
while (_check_for_overlap((float)(_angle),_spacing)==anywheresoftware.b4a.keywords.Common.True) {
 //BA.debugLineNum = 560;BA.debugLine="angle = crunch(angle + 1)";
_angle = _vv6(_angle+1);
 }
;
 //BA.debugLineNum = 564;BA.debugLine="spot_filled(Round(angle)) = 1";
_spot_filled[(int)(anywheresoftware.b4a.keywords.Common.Round(_angle))] = (int)(1);
 //BA.debugLineNum = 565;BA.debugLine="spot_filled(crunch(Round(angle) - 1)) = 1        'allows For a little better separation between Mars AND Sun on 3/13/1966 test example";
_spot_filled[(int)(_vv6(anywheresoftware.b4a.keywords.Common.Round(_angle)-1))] = (int)(1);
 //BA.debugLineNum = 568;BA.debugLine="planet_angle(kk, sort_pos(i)) = angle              'needed for aspect lines";
_planet_angle[_kk][_sort_pos[_i]] = (int)(_angle);
 //BA.debugLineNum = 569;BA.debugLine="our_angle = angle                              'needed for placing info on chartwheel";
_our_angle = _angle;
 //BA.debugLineNum = 571;BA.debugLine="angle_to_use = d2r * our_angle";
_angle_to_use = (float)(_v0*_our_angle);
 //BA.debugLineNum = 574;BA.debugLine="planets_done = planets_done + 1";
_planets_done = (int)(_planets_done+1);
 //BA.debugLineNum = 576;BA.debugLine="xy = display_planet_glyph(our_angle, angle_to_use, radius - offset_distance)";
_xy = _display_planet_glyph((float)(_our_angle),_angle_to_use,(int)(_radius-_offset_distance));
 //BA.debugLineNum = 578;BA.debugLine="If kk = 0 Then";
if (_kk==0) { 
 //BA.debugLineNum = 579;BA.debugLine="cvsLayer.DrawText(Chr(pl_glyph(sort_pos(i))), xy(0) + center_pt_x, xy(1) + center_pt_y, HamburgFont, 32, Colors.Cyan, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,String.valueOf(anywheresoftware.b4a.keywords.Common.Chr(_pl_glyph[_sort_pos[_i]])),(float)(_xy[(int)(0)]+_center_pt_x),(float)(_xy[(int)(1)]+_center_pt_y),(android.graphics.Typeface)(mostCurrent._v7.getObject()),(float)(32),anywheresoftware.b4a.keywords.Common.Colors.Cyan,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 }else {
 //BA.debugLineNum = 581;BA.debugLine="cvsLayer.DrawText(Chr(pl_glyph(sort_pos(i))), xy(0) + center_pt_x, xy(1) + center_pt_y, HamburgFont, 32, Colors.Magenta, \"LEFT\")";
mostCurrent._vv1.DrawText(mostCurrent.activityBA,String.valueOf(anywheresoftware.b4a.keywords.Common.Chr(_pl_glyph[_sort_pos[_i]])),(float)(_xy[(int)(0)]+_center_pt_x),(float)(_xy[(int)(1)]+_center_pt_y),(android.graphics.Typeface)(mostCurrent._v7.getObject()),(float)(32),anywheresoftware.b4a.keywords.Common.Colors.Magenta,BA.getEnumFromString(android.graphics.Paint.Align.class,"LEFT"));
 };
 }
};
 }
};
 //BA.debugLineNum = 629;BA.debugLine="For i = 0 To 5						'transit planet";
{
final double step381 = 1;
final double limit381 = (int)(5);
for (_i = (int)(0); (step381 > 0 && _i <= limit381) || (step381 < 0 && _i >= limit381); _i += step381) {
 //BA.debugLineNum = 630;BA.debugLine="For j = 0 To 9          'natal planet";
{
final double step382 = 1;
final double limit382 = (int)(9);
for (_j = (int)(0); (step382 > 0 && _j <= limit382) || (step382 < 0 && _j >= limit382); _j += step382) {
 //BA.debugLineNum = 631;BA.debugLine="q = aspect_present(i, j)";
_q = _aspect_present[_i][_j];
 //BA.debugLineNum = 633;BA.debugLine="If q > 1 Then";
if (_q>1) { 
 //BA.debugLineNum = 642;BA.debugLine="inner_radius = 30";
_inner_radius = (int)(30);
 //BA.debugLineNum = 644;BA.debugLine="x1 = (-radius - 10) * Cos(d2r * planet_angle(1, i))";
_x1 = (float)((-_radius-10)*anywheresoftware.b4a.keywords.Common.Cos(_v0*_planet_angle[(int)(1)][_i]));
 //BA.debugLineNum = 645;BA.debugLine="y1 = (radius + 10) * Sin(d2r * planet_angle(1, i))";
_y1 = (float)((_radius+10)*anywheresoftware.b4a.keywords.Common.Sin(_v0*_planet_angle[(int)(1)][_i]));
 //BA.debugLineNum = 647;BA.debugLine="x2 = (-radius + inner_radius) * Cos(d2r * planet_angle(0, j))";
_x2 = (float)((-_radius+_inner_radius)*anywheresoftware.b4a.keywords.Common.Cos(_v0*_planet_angle[(int)(0)][_j]));
 //BA.debugLineNum = 648;BA.debugLine="y2 = (radius - inner_radius) * Sin(d2r * planet_angle(0, j))";
_y2 = (float)((_radius-_inner_radius)*anywheresoftware.b4a.keywords.Common.Sin(_v0*_planet_angle[(int)(0)][_j]));
 //BA.debugLineNum = 650;BA.debugLine="If q = 3 OR q = 5 Then";
if (_q==3 || _q==5) { 
 //BA.debugLineNum = 651;BA.debugLine="cvsLayer.DrawLine(x1 + center_pt_x, y1 + center_pt_y, x2 + center_pt_x, y2 + center_pt_y, Colors.Green, 2dip)";
mostCurrent._vv1.DrawLine((float)(_x1+_center_pt_x),(float)(_y1+_center_pt_y),(float)(_x2+_center_pt_x),(float)(_y2+_center_pt_y),anywheresoftware.b4a.keywords.Common.Colors.Green,(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2))));
 }else if(_q==4 || _q==6) { 
 //BA.debugLineNum = 653;BA.debugLine="cvsLayer.DrawLine(x1 + center_pt_x, y1 + center_pt_y, x2 + center_pt_x, y2 + center_pt_y, Colors.Red, 2dip)";
mostCurrent._vv1.DrawLine((float)(_x1+_center_pt_x),(float)(_y1+_center_pt_y),(float)(_x2+_center_pt_x),(float)(_y2+_center_pt_y),anywheresoftware.b4a.keywords.Common.Colors.Red,(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2))));
 }else if(_q==2) { 
 //BA.debugLineNum = 655;BA.debugLine="cvsLayer.DrawLine(x1 + center_pt_x, y1 + center_pt_y, x2 + center_pt_x, y2 + center_pt_y, Colors.Yellow, 4dip)";
mostCurrent._vv1.DrawLine((float)(_x1+_center_pt_x),(float)(_y1+_center_pt_y),(float)(_x2+_center_pt_x),(float)(_y2+_center_pt_y),anywheresoftware.b4a.keywords.Common.Colors.Yellow,(float)(anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(4))));
 };
 };
 }
};
 }
};
 };
 //BA.debugLineNum = 664;BA.debugLine="End Sub";
return "";
}
public static String  _find_specific_report_paragraph(String _phrase_to_look_for,String _filename) throws Exception{
String _txt = "";
int _n = 0;
int _x = 0;
int _y = 0;
 //BA.debugLineNum = 691;BA.debugLine="Sub Find_Specific_Report_Paragraph(phrase_to_look_for As String, filename As String) As String";
 //BA.debugLineNum = 692;BA.debugLine="Dim txt As String";
_txt = "";
 //BA.debugLineNum = 693;BA.debugLine="Dim n, x, y As Int";
_n = 0;
_x = 0;
_y = 0;
 //BA.debugLineNum = 700;BA.debugLine="If File.Exists(File.DirAssets, filename) = False Then Return \"\"";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),_filename)==anywheresoftware.b4a.keywords.Common.False) { 
if (true) return "";};
 //BA.debugLineNum = 702;BA.debugLine="txt = File.ReadString(File.DirAssets, filename)";
_txt = anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),_filename);
 //BA.debugLineNum = 705;BA.debugLine="x = txt.IndexOf(phrase_to_look_for)";
_x = _txt.indexOf(_phrase_to_look_for);
 //BA.debugLineNum = 707;BA.debugLine="If x = -1 Then Return \"\"";
if (_x==-1) { 
if (true) return "";};
 //BA.debugLineNum = 709;BA.debugLine="y = txt.IndexOf2(\"*\", x)";
_y = _txt.indexOf("*",_x);
 //BA.debugLineNum = 710;BA.debugLine="n = y - x - 1";
_n = (int)(_y-_x-1);
 //BA.debugLineNum = 712;BA.debugLine="Return txt.SubString2(x - 1, x + n - 1)";
if (true) return _txt.substring((int)(_x-1),(int)(_x+_n-1));
 //BA.debugLineNum = 713;BA.debugLine="End Sub";
return "";
}
public static double  _get_1_planet(double _jd,int _p_num) throws Exception{
double[] _xx = null;
anywheresoftware.b4a.keywords.StringBuilderWrapper _serr = null;
int _iflag = 0;
int _ret_flag = 0;
int _i = 0;
 //BA.debugLineNum = 719;BA.debugLine="Sub Get_1_Planet(JD As Double, p_num As Int) As Double";
 //BA.debugLineNum = 720;BA.debugLine="Dim xx(7) As Double";
_xx = new double[(int)(7)];
;
 //BA.debugLineNum = 721;BA.debugLine="Dim serr As StringBuilder";
_serr = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 722;BA.debugLine="Dim iflag As Int";
_iflag = 0;
 //BA.debugLineNum = 723;BA.debugLine="Dim ret_flag As Int";
_ret_flag = 0;
 //BA.debugLineNum = 725;BA.debugLine="serr.Initialize";
_serr.Initialize();
 //BA.debugLineNum = 726;BA.debugLine="For i = 1 To 255";
{
final double step443 = 1;
final double limit443 = (int)(255);
for (_i = (int)(1); (step443 > 0 && _i <= limit443) || (step443 < 0 && _i >= limit443); _i += step443) {
 //BA.debugLineNum = 727;BA.debugLine="serr.Append(\"0\")";
_serr.Append("0");
 }
};
 //BA.debugLineNum = 730;BA.debugLine="iflag = 2 + 256";
_iflag = (int)(2+256);
 //BA.debugLineNum = 737;BA.debugLine="ret_flag = swe1.swe_calc_ut(JD, p_num, iflag, xx, serr)";
_ret_flag = _vvv2.swe_calc_ut(_jd,_p_num,_iflag,_xx,(java.lang.StringBuilder)(_serr.getObject()));
 //BA.debugLineNum = 739;BA.debugLine="Return xx(0)";
if (true) return _xx[(int)(0)];
 //BA.debugLineNum = 740;BA.debugLine="End Sub";
return 0;
}
public static String  _get_transit_interps_for_this_day(double _jdx) throws Exception{
int _d = 0;
int _i = 0;
int _j = 0;
int _m = 0;
int _q = 0;
int _y = 0;
long _ret_flag = 0L;
String _any_text = "";
String _filename = "";
String _phrase_to_look_for = "";
String _t = "";
String _txt = "";
double _orb = 0;
double _tod = 0;
String _da = "";
 //BA.debugLineNum = 897;BA.debugLine="Sub Get_transit_interps_for_this_day(jdx As Double)";
 //BA.debugLineNum = 898;BA.debugLine="Dim d, i, j, M, q, y As Int";
_d = 0;
_i = 0;
_j = 0;
_m = 0;
_q = 0;
_y = 0;
 //BA.debugLineNum = 899;BA.debugLine="Dim ret_flag As Long";
_ret_flag = 0L;
 //BA.debugLineNum = 900;BA.debugLine="Dim any_text, filename, phrase_to_look_for, t, txt As String";
_any_text = "";
_filename = "";
_phrase_to_look_for = "";
_t = "";
_txt = "";
 //BA.debugLineNum = 901;BA.debugLine="Dim orb, tod As Double";
_orb = 0;
_tod = 0;
 //BA.debugLineNum = 905;BA.debugLine="EditText1.Text = \"\"";
mostCurrent._edittext1.setText((Object)(""));
 //BA.debugLineNum = 907;BA.debugLine="transit_data_header = ConvertJDtoDateandTime(jdx)";
_transit_data_header = _vv7(_jdx);
 //BA.debugLineNum = 910;BA.debugLine="transit_data = \"\"";
_transit_data = "";
 //BA.debugLineNum = 911;BA.debugLine="For i = 0 To 9";
{
final double step596 = 1;
final double limit596 = (int)(9);
for (_i = (int)(0); (step596 > 0 && _i <= limit596) || (step596 < 0 && _i >= limit596); _i += step596) {
 //BA.debugLineNum = 912;BA.debugLine="Transit(i) = Get_1_Planet(jdx, i)";
_vvv1[_i] = _get_1_planet(_jdx,_i);
 //BA.debugLineNum = 914;BA.debugLine="transit_data = transit_data & p_names(i) & \" = \" & Convert_Longitude(Transit(i)) & \"   -   \" & NumberFormat2(Transit(i), 1, 4, 4, False) & CRLF";
_transit_data = _transit_data+_p_names[_i]+" = "+_convert_longitude((float)(_vvv1[_i]))+"   -   "+anywheresoftware.b4a.keywords.Common.NumberFormat2(_vvv1[_i],(int)(1),(int)(4),(int)(4),anywheresoftware.b4a.keywords.Common.False)+anywheresoftware.b4a.keywords.Common.CRLF;
 }
};
 //BA.debugLineNum = 917;BA.debugLine="If chkDebug.Checked = True Then";
if (mostCurrent._chkdebug.getChecked()==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 918;BA.debugLine="EditText1.Text = transit_data_header & CRLF & transit_data & CRLF & natal_data_header & CRLF & natal_data & CRLF";
mostCurrent._edittext1.setText((Object)(_transit_data_header+anywheresoftware.b4a.keywords.Common.CRLF+_transit_data+anywheresoftware.b4a.keywords.Common.CRLF+_natal_data_header+anywheresoftware.b4a.keywords.Common.CRLF+_natal_data+anywheresoftware.b4a.keywords.Common.CRLF));
 }else {
 //BA.debugLineNum = 920;BA.debugLine="EditText1.Text = transit_data_header & CRLF & natal_data_header & CRLF";
mostCurrent._edittext1.setText((Object)(_transit_data_header+anywheresoftware.b4a.keywords.Common.CRLF+_natal_data_header+anywheresoftware.b4a.keywords.Common.CRLF));
 };
 //BA.debugLineNum = 924;BA.debugLine="orb = 2.0";
_orb = 2.0;
 //BA.debugLineNum = 925;BA.debugLine="any_text = \"\"";
_any_text = "";
 //BA.debugLineNum = 927;BA.debugLine="For i = 0 To 5                          'transit planet";
{
final double step607 = 1;
final double limit607 = (int)(5);
for (_i = (int)(0); (step607 > 0 && _i <= limit607) || (step607 < 0 && _i >= limit607); _i += step607) {
 //BA.debugLineNum = 928;BA.debugLine="If i = 1 Then Continue";
if (_i==1) { 
if (true) continue;};
 //BA.debugLineNum = 930;BA.debugLine="For j = 0 To 9					              'natal planet";
{
final double step609 = 1;
final double limit609 = (int)(9);
for (_j = (int)(0); (step609 > 0 && _j <= limit609) || (step609 < 0 && _j >= limit609); _j += step609) {
 //BA.debugLineNum = 931;BA.debugLine="aspect_present(i, j) = 0						'clear the record of this possible aspect";
_aspect_present[_i][_j] = (int)(0);
 //BA.debugLineNum = 933;BA.debugLine="da = Abs(Natal(j) - Transit(i))";
_da = BA.NumberToString(anywheresoftware.b4a.keywords.Common.Abs(_vv4[_j]-_vvv1[_i]));
 //BA.debugLineNum = 934;BA.debugLine="If da > 180 Then da = 360 - da";
if ((double)(Double.parseDouble(_da))>180) { 
_da = BA.NumberToString(360-(double)(Double.parseDouble(_da)));};
 //BA.debugLineNum = 936;BA.debugLine="q = 1";
_q = (int)(1);
 //BA.debugLineNum = 937;BA.debugLine="If da <= orb Then";
if ((double)(Double.parseDouble(_da))<=_orb) { 
 //BA.debugLineNum = 938;BA.debugLine="q = 2";
_q = (int)(2);
 }else if((double)(Double.parseDouble(_da))<=60+_orb && (double)(Double.parseDouble(_da))>=60-_orb) { 
 //BA.debugLineNum = 940;BA.debugLine="q = 3";
_q = (int)(3);
 }else if((double)(Double.parseDouble(_da))<=90+_orb && (double)(Double.parseDouble(_da))>=90-_orb) { 
 //BA.debugLineNum = 942;BA.debugLine="q = 4";
_q = (int)(4);
 }else if((double)(Double.parseDouble(_da))<=120+_orb && (double)(Double.parseDouble(_da))>=120-_orb) { 
 //BA.debugLineNum = 944;BA.debugLine="q = 5";
_q = (int)(5);
 }else if((double)(Double.parseDouble(_da))>=180-_orb) { 
 //BA.debugLineNum = 946;BA.debugLine="q = 6";
_q = (int)(6);
 };
 //BA.debugLineNum = 949;BA.debugLine="If q > 1 Then";
if (_q>1) { 
 //BA.debugLineNum = 950;BA.debugLine="aspect_present(i, j) = q";
_aspect_present[_i][_j] = _q;
 //BA.debugLineNum = 952;BA.debugLine="phrase_to_look_for = p_names(i) & asp_names(q) & p_names(j)		'i = transit, j = natal";
_phrase_to_look_for = _p_names[_i]+_asp_names[_q]+_p_names[_j];
 //BA.debugLineNum = 953;BA.debugLine="filename = p_names(i) & \"_tr.txt\"";
_filename = _p_names[_i]+"_tr.txt";
 //BA.debugLineNum = 955;BA.debugLine="txt = Find_Specific_Report_Paragraph(phrase_to_look_for, filename)";
_txt = _find_specific_report_paragraph(_phrase_to_look_for,_filename);
 //BA.debugLineNum = 956;BA.debugLine="any_text = \"xxx\"";
_any_text = "xxx";
 //BA.debugLineNum = 958;BA.debugLine="EditText1.Text = EditText1.Text & txt & CRLF";
mostCurrent._edittext1.setText((Object)(mostCurrent._edittext1.getText()+_txt+anywheresoftware.b4a.keywords.Common.CRLF));
 };
 }
};
 }
};
 //BA.debugLineNum = 963;BA.debugLine="If any_text = \"\" Then";
if ((_any_text).equals("")) { 
 //BA.debugLineNum = 964;BA.debugLine="EditText1.Text = EditText1.Text & CRLF & \"You have no transits active at this time.\" & CRLF";
mostCurrent._edittext1.setText((Object)(mostCurrent._edittext1.getText()+anywheresoftware.b4a.keywords.Common.CRLF+"You have no transits active at this time."+anywheresoftware.b4a.keywords.Common.CRLF));
 };
 //BA.debugLineNum = 967;BA.debugLine="last_interp_text = EditText1.Text";
_last_interp_text = mostCurrent._edittext1.getText();
 //BA.debugLineNum = 968;BA.debugLine="End Sub";
return "";
}
public static String  _vv0(double _jdx) throws Exception{
long _lw = 0L;
long _itw = 0L;
long _kw = 0L;
long _ikw = 0L;
long _nw = 0L;
long _jtw = 0L;
String _calendar = "";
 //BA.debugLineNum = 993;BA.debugLine="Sub GetCalendarDate(jdx As Double)";
 //BA.debugLineNum = 994;BA.debugLine="Dim lw, itw, kw, ikw, nw, jtw As Long";
_lw = 0L;
_itw = 0L;
_kw = 0L;
_ikw = 0L;
_nw = 0L;
_jtw = 0L;
 //BA.debugLineNum = 995;BA.debugLine="Dim calendar As String";
_calendar = "";
 //BA.debugLineNum = 998;BA.debugLine="lw = Floor(jdx + 0.5) + 68569";
_lw = (long)(anywheresoftware.b4a.keywords.Common.Floor(_jdx+0.5)+68569);
 //BA.debugLineNum = 999;BA.debugLine="nw = Floor(4 * lw / 146097)";
_nw = (long)(anywheresoftware.b4a.keywords.Common.Floor(4*_lw/(double)146097));
 //BA.debugLineNum = 1000;BA.debugLine="lw = lw - Floor((146097 * nw + 3) / 4)";
_lw = (long)(_lw-anywheresoftware.b4a.keywords.Common.Floor((146097*_nw+3)/(double)4));
 //BA.debugLineNum = 1001;BA.debugLine="itw = Floor(4000 * (lw + 1) / 1461001)";
_itw = (long)(anywheresoftware.b4a.keywords.Common.Floor(4000*(_lw+1)/(double)1461001));
 //BA.debugLineNum = 1002;BA.debugLine="lw = lw - Floor(1461 * itw / 4) + 31";
_lw = (long)(_lw-anywheresoftware.b4a.keywords.Common.Floor(1461*_itw/(double)4)+31);
 //BA.debugLineNum = 1003;BA.debugLine="jtw = Floor(80 * lw / 2447)";
_jtw = (long)(anywheresoftware.b4a.keywords.Common.Floor(80*_lw/(double)2447));
 //BA.debugLineNum = 1004;BA.debugLine="kw = lw - Floor(2447 * jtw / 80)";
_kw = (long)(_lw-anywheresoftware.b4a.keywords.Common.Floor(2447*_jtw/(double)80));
 //BA.debugLineNum = 1005;BA.debugLine="lw = Floor(jtw / 11)";
_lw = (long)(anywheresoftware.b4a.keywords.Common.Floor(_jtw/(double)11));
 //BA.debugLineNum = 1006;BA.debugLine="jtw = jtw + 2 - 12 * lw";
_jtw = (long)(_jtw+2-12*_lw);
 //BA.debugLineNum = 1007;BA.debugLine="ikw = 100 * (nw - 49) + itw + lw";
_ikw = (long)(100*(_nw-49)+_itw+_lw);
 //BA.debugLineNum = 1010;BA.debugLine="Return NumberFormat(kw, 2, 0) & \" \" & month_names(jtw) & \" \" & ikw";
if (true) return anywheresoftware.b4a.keywords.Common.NumberFormat(_kw,(int)(2),(int)(0))+" "+_month_names[(int)(_jtw)]+" "+BA.NumberToString(_ikw);
 //BA.debugLineNum = 1011;BA.debugLine="End Sub";
return "";
}
public static String  _vv2(float _current_tz) throws Exception{
anywheresoftware.b4a.objects.collections.List _list2 = null;
float _tz = 0f;
int _idx = 0;
String _res = "";
 //BA.debugLineNum = 762;BA.debugLine="Sub GetNatalTimeZone(current_tz As Float)";
 //BA.debugLineNum = 763;BA.debugLine="Dim List2 As List";
_list2 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 764;BA.debugLine="Dim tz As Float";
_tz = 0f;
 //BA.debugLineNum = 765;BA.debugLine="Dim idx As Int";
_idx = 0;
 //BA.debugLineNum = 768;BA.debugLine="If current_tz = -12 Then idx = 0";
if (_current_tz==-12) { 
_idx = (int)(0);};
 //BA.debugLineNum = 769;BA.debugLine="If current_tz = -11 Then idx = 1";
if (_current_tz==-11) { 
_idx = (int)(1);};
 //BA.debugLineNum = 770;BA.debugLine="If current_tz = -10.5 Then idx = 2";
if (_current_tz==-10.5) { 
_idx = (int)(2);};
 //BA.debugLineNum = 771;BA.debugLine="If current_tz = -10 Then idx = 3";
if (_current_tz==-10) { 
_idx = (int)(3);};
 //BA.debugLineNum = 772;BA.debugLine="If current_tz = -9.5 Then idx = 4";
if (_current_tz==-9.5) { 
_idx = (int)(4);};
 //BA.debugLineNum = 773;BA.debugLine="If current_tz = -9 Then idx = 5";
if (_current_tz==-9) { 
_idx = (int)(5);};
 //BA.debugLineNum = 774;BA.debugLine="If current_tz = -8 Then idx = 6";
if (_current_tz==-8) { 
_idx = (int)(6);};
 //BA.debugLineNum = 775;BA.debugLine="If current_tz = -7 Then idx = 7";
if (_current_tz==-7) { 
_idx = (int)(7);};
 //BA.debugLineNum = 776;BA.debugLine="If current_tz = -6 Then idx = 8";
if (_current_tz==-6) { 
_idx = (int)(8);};
 //BA.debugLineNum = 777;BA.debugLine="If current_tz = -5 Then idx = 9";
if (_current_tz==-5) { 
_idx = (int)(9);};
 //BA.debugLineNum = 778;BA.debugLine="If current_tz = -4 Then idx = 10";
if (_current_tz==-4) { 
_idx = (int)(10);};
 //BA.debugLineNum = 779;BA.debugLine="If current_tz = -3.5 Then idx = 11";
if (_current_tz==-3.5) { 
_idx = (int)(11);};
 //BA.debugLineNum = 780;BA.debugLine="If current_tz = -3 Then idx = 12";
if (_current_tz==-3) { 
_idx = (int)(12);};
 //BA.debugLineNum = 781;BA.debugLine="If current_tz = -2 Then idx = 13";
if (_current_tz==-2) { 
_idx = (int)(13);};
 //BA.debugLineNum = 782;BA.debugLine="If current_tz = -1 Then idx = 14";
if (_current_tz==-1) { 
_idx = (int)(14);};
 //BA.debugLineNum = 783;BA.debugLine="If current_tz = 0 Then idx = 15";
if (_current_tz==0) { 
_idx = (int)(15);};
 //BA.debugLineNum = 784;BA.debugLine="If current_tz = 1 Then idx = 16";
if (_current_tz==1) { 
_idx = (int)(16);};
 //BA.debugLineNum = 785;BA.debugLine="If current_tz = 2 Then idx = 17";
if (_current_tz==2) { 
_idx = (int)(17);};
 //BA.debugLineNum = 786;BA.debugLine="If current_tz = 3 Then idx = 18";
if (_current_tz==3) { 
_idx = (int)(18);};
 //BA.debugLineNum = 787;BA.debugLine="If current_tz = 3.5 Then idx = 19";
if (_current_tz==3.5) { 
_idx = (int)(19);};
 //BA.debugLineNum = 788;BA.debugLine="If current_tz = 4 Then idx = 20";
if (_current_tz==4) { 
_idx = (int)(20);};
 //BA.debugLineNum = 789;BA.debugLine="If current_tz = 5 Then idx = 21";
if (_current_tz==5) { 
_idx = (int)(21);};
 //BA.debugLineNum = 790;BA.debugLine="If current_tz = 5.5 Then idx = 22";
if (_current_tz==5.5) { 
_idx = (int)(22);};
 //BA.debugLineNum = 791;BA.debugLine="If current_tz = 6 Then idx = 23";
if (_current_tz==6) { 
_idx = (int)(23);};
 //BA.debugLineNum = 792;BA.debugLine="If current_tz = 6.5 Then idx = 24";
if (_current_tz==6.5) { 
_idx = (int)(24);};
 //BA.debugLineNum = 793;BA.debugLine="If current_tz = 7 Then idx = 25";
if (_current_tz==7) { 
_idx = (int)(25);};
 //BA.debugLineNum = 794;BA.debugLine="If current_tz = 7.5 Then idx = 26";
if (_current_tz==7.5) { 
_idx = (int)(26);};
 //BA.debugLineNum = 795;BA.debugLine="If current_tz = 8 Then idx = 27";
if (_current_tz==8) { 
_idx = (int)(27);};
 //BA.debugLineNum = 796;BA.debugLine="If current_tz = 8.5 Then idx = 28";
if (_current_tz==8.5) { 
_idx = (int)(28);};
 //BA.debugLineNum = 797;BA.debugLine="If current_tz = 9 Then idx = 29";
if (_current_tz==9) { 
_idx = (int)(29);};
 //BA.debugLineNum = 798;BA.debugLine="If current_tz = 9.5 Then idx = 30";
if (_current_tz==9.5) { 
_idx = (int)(30);};
 //BA.debugLineNum = 799;BA.debugLine="If current_tz = 10 Then idx = 31";
if (_current_tz==10) { 
_idx = (int)(31);};
 //BA.debugLineNum = 800;BA.debugLine="If current_tz = 10.5 Then idx = 32";
if (_current_tz==10.5) { 
_idx = (int)(32);};
 //BA.debugLineNum = 801;BA.debugLine="If current_tz = 11 Then idx = 33";
if (_current_tz==11) { 
_idx = (int)(33);};
 //BA.debugLineNum = 802;BA.debugLine="If current_tz = 11.5 Then idx = 34";
if (_current_tz==11.5) { 
_idx = (int)(34);};
 //BA.debugLineNum = 803;BA.debugLine="If current_tz = 12 Then idx = 35";
if (_current_tz==12) { 
_idx = (int)(35);};
 //BA.debugLineNum = 804;BA.debugLine="If current_tz = 12.5 Then idx = 36";
if (_current_tz==12.5) { 
_idx = (int)(36);};
 //BA.debugLineNum = 805;BA.debugLine="If current_tz = 13 Then idx = 37";
if (_current_tz==13) { 
_idx = (int)(37);};
 //BA.debugLineNum = 808;BA.debugLine="List2.Initialize";
_list2.Initialize();
 //BA.debugLineNum = 810;BA.debugLine="List2.Add(\"GMT -12:00 hrs - IDLW\")";
_list2.Add((Object)("GMT -12:00 hrs - IDLW"));
 //BA.debugLineNum = 811;BA.debugLine="List2.Add(\"GMT -11:00 hrs - BET or NT\")";
_list2.Add((Object)("GMT -11:00 hrs - BET or NT"));
 //BA.debugLineNum = 812;BA.debugLine="List2.Add(\"GMT -10:30 hrs - HST\")";
_list2.Add((Object)("GMT -10:30 hrs - HST"));
 //BA.debugLineNum = 813;BA.debugLine="List2.Add(\"GMT -10:00 hrs - AHST\")";
_list2.Add((Object)("GMT -10:00 hrs - AHST"));
 //BA.debugLineNum = 814;BA.debugLine="List2.Add(\"GMT -09:30 hrs - HDT or HWT\")";
_list2.Add((Object)("GMT -09:30 hrs - HDT or HWT"));
 //BA.debugLineNum = 815;BA.debugLine="List2.Add(\"GMT -09:00 hrs - YST or AHDT or AHWT\")";
_list2.Add((Object)("GMT -09:00 hrs - YST or AHDT or AHWT"));
 //BA.debugLineNum = 816;BA.debugLine="List2.Add(\"GMT -08:00 hrs - PST or YDT or YWT\")";
_list2.Add((Object)("GMT -08:00 hrs - PST or YDT or YWT"));
 //BA.debugLineNum = 817;BA.debugLine="List2.Add(\"GMT -07:00 hrs - MST or PDT or PWT\")";
_list2.Add((Object)("GMT -07:00 hrs - MST or PDT or PWT"));
 //BA.debugLineNum = 818;BA.debugLine="List2.Add(\"GMT -06:00 hrs - CST or MDT or MWT\")";
_list2.Add((Object)("GMT -06:00 hrs - CST or MDT or MWT"));
 //BA.debugLineNum = 819;BA.debugLine="List2.Add(\"GMT -05:00 hrs - EST or CDT or CWT\")";
_list2.Add((Object)("GMT -05:00 hrs - EST or CDT or CWT"));
 //BA.debugLineNum = 820;BA.debugLine="List2.Add(\"GMT -04:00 hrs - AST or EDT or EWT\")";
_list2.Add((Object)("GMT -04:00 hrs - AST or EDT or EWT"));
 //BA.debugLineNum = 821;BA.debugLine="List2.Add(\"GMT -03:30 hrs - NST\")";
_list2.Add((Object)("GMT -03:30 hrs - NST"));
 //BA.debugLineNum = 822;BA.debugLine="List2.Add(\"GMT -03:00 hrs - BZT2 or AWT\")";
_list2.Add((Object)("GMT -03:00 hrs - BZT2 or AWT"));
 //BA.debugLineNum = 823;BA.debugLine="List2.Add(\"GMT -02:00 hrs - AT\")";
_list2.Add((Object)("GMT -02:00 hrs - AT"));
 //BA.debugLineNum = 824;BA.debugLine="List2.Add(\"GMT -01:00 hrs - WAT\")";
_list2.Add((Object)("GMT -01:00 hrs - WAT"));
 //BA.debugLineNum = 825;BA.debugLine="List2.Add(\"Greenwich Mean Time - GMT or UT\")";
_list2.Add((Object)("Greenwich Mean Time - GMT or UT"));
 //BA.debugLineNum = 826;BA.debugLine="List2.Add(\"GMT +01:00 hrs - CET or MET or BST\")";
_list2.Add((Object)("GMT +01:00 hrs - CET or MET or BST"));
 //BA.debugLineNum = 827;BA.debugLine="List2.Add(\"GMT +02:00 hrs - EET or CED or MED\")";
_list2.Add((Object)("GMT +02:00 hrs - EET or CED or MED"));
 //BA.debugLineNum = 828;BA.debugLine="List2.Add(\"GMT +03:00 hrs - BAT or EED\")";
_list2.Add((Object)("GMT +03:00 hrs - BAT or EED"));
 //BA.debugLineNum = 829;BA.debugLine="List2.Add(\"GMT +03:30 hrs - IT\")";
_list2.Add((Object)("GMT +03:30 hrs - IT"));
 //BA.debugLineNum = 830;BA.debugLine="List2.Add(\"GMT +04:00 hrs - USZ3\")";
_list2.Add((Object)("GMT +04:00 hrs - USZ3"));
 //BA.debugLineNum = 831;BA.debugLine="List2.Add(\"GMT +05:00 hrs - USZ4\")";
_list2.Add((Object)("GMT +05:00 hrs - USZ4"));
 //BA.debugLineNum = 832;BA.debugLine="List2.Add(\"GMT +05:30 hrs - IST\")";
_list2.Add((Object)("GMT +05:30 hrs - IST"));
 //BA.debugLineNum = 833;BA.debugLine="List2.Add(\"GMT +06:00 hrs - USZ5\")";
_list2.Add((Object)("GMT +06:00 hrs - USZ5"));
 //BA.debugLineNum = 834;BA.debugLine="List2.Add(\"GMT +06:30 hrs - NST\")";
_list2.Add((Object)("GMT +06:30 hrs - NST"));
 //BA.debugLineNum = 835;BA.debugLine="List2.Add(\"GMT +07:00 hrs - SST or USZ6\")";
_list2.Add((Object)("GMT +07:00 hrs - SST or USZ6"));
 //BA.debugLineNum = 836;BA.debugLine="List2.Add(\"GMT +07:30 hrs - JT\")";
_list2.Add((Object)("GMT +07:30 hrs - JT"));
 //BA.debugLineNum = 837;BA.debugLine="List2.Add(\"GMT +08:00 hrs - AWST or CCT\")";
_list2.Add((Object)("GMT +08:00 hrs - AWST or CCT"));
 //BA.debugLineNum = 838;BA.debugLine="List2.Add(\"GMT +08:30 hrs - MT\")";
_list2.Add((Object)("GMT +08:30 hrs - MT"));
 //BA.debugLineNum = 839;BA.debugLine="List2.Add(\"GMT +09:00 hrs - JST or AWDT\")";
_list2.Add((Object)("GMT +09:00 hrs - JST or AWDT"));
 //BA.debugLineNum = 840;BA.debugLine="List2.Add(\"GMT +09:30 hrs - ACST or SAT or SAST\")";
_list2.Add((Object)("GMT +09:30 hrs - ACST or SAT or SAST"));
 //BA.debugLineNum = 841;BA.debugLine="List2.Add(\"GMT +10:00 hrs - AEST or GST\")";
_list2.Add((Object)("GMT +10:00 hrs - AEST or GST"));
 //BA.debugLineNum = 842;BA.debugLine="List2.Add(\"GMT +10:30 hrs - ACDT or SDT or SAD\")";
_list2.Add((Object)("GMT +10:30 hrs - ACDT or SDT or SAD"));
 //BA.debugLineNum = 843;BA.debugLine="List2.Add(\"GMT +11:00 hrs - UZ10 or AEDT\")";
_list2.Add((Object)("GMT +11:00 hrs - UZ10 or AEDT"));
 //BA.debugLineNum = 844;BA.debugLine="List2.Add(\"GMT +11:30 hrs - NZ\")";
_list2.Add((Object)("GMT +11:30 hrs - NZ"));
 //BA.debugLineNum = 845;BA.debugLine="List2.Add(\"GMT +12:00 hrs - NZT or IDLE\")";
_list2.Add((Object)("GMT +12:00 hrs - NZT or IDLE"));
 //BA.debugLineNum = 846;BA.debugLine="List2.Add(\"GMT +12:30 hrs - NZS\")";
_list2.Add((Object)("GMT +12:30 hrs - NZS"));
 //BA.debugLineNum = 847;BA.debugLine="List2.Add(\"GMT +13:00 hrs - NZST\")";
_list2.Add((Object)("GMT +13:00 hrs - NZST"));
 //BA.debugLineNum = 849;BA.debugLine="res = InputList(List2, \"Choose time zone\", idx)          'display list of options";
_res = BA.NumberToString(anywheresoftware.b4a.keywords.Common.InputList(_list2,"Choose time zone",_idx,mostCurrent.activityBA));
 //BA.debugLineNum = 851;BA.debugLine="tz = 0";
_tz = (float)(0);
 //BA.debugLineNum = 853;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if ((_res).equals(BA.NumberToString(anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL)) == false) { 
 //BA.debugLineNum = 854;BA.debugLine="If res = 0 Then tz = -12";
if ((_res).equals(BA.NumberToString(0))) { 
_tz = (float)(-12);};
 //BA.debugLineNum = 855;BA.debugLine="If res = 1 Then tz = -11";
if ((_res).equals(BA.NumberToString(1))) { 
_tz = (float)(-11);};
 //BA.debugLineNum = 856;BA.debugLine="If res = 2 Then tz = -10.5";
if ((_res).equals(BA.NumberToString(2))) { 
_tz = (float)(-10.5);};
 //BA.debugLineNum = 857;BA.debugLine="If res = 3 Then tz = -10";
if ((_res).equals(BA.NumberToString(3))) { 
_tz = (float)(-10);};
 //BA.debugLineNum = 858;BA.debugLine="If res = 4 Then tz = -9.5";
if ((_res).equals(BA.NumberToString(4))) { 
_tz = (float)(-9.5);};
 //BA.debugLineNum = 859;BA.debugLine="If res = 5 Then tz = -9";
if ((_res).equals(BA.NumberToString(5))) { 
_tz = (float)(-9);};
 //BA.debugLineNum = 860;BA.debugLine="If res = 6 Then tz = -8";
if ((_res).equals(BA.NumberToString(6))) { 
_tz = (float)(-8);};
 //BA.debugLineNum = 861;BA.debugLine="If res = 7 Then tz = -7";
if ((_res).equals(BA.NumberToString(7))) { 
_tz = (float)(-7);};
 //BA.debugLineNum = 862;BA.debugLine="If res = 8 Then tz = -6";
if ((_res).equals(BA.NumberToString(8))) { 
_tz = (float)(-6);};
 //BA.debugLineNum = 863;BA.debugLine="If res = 9 Then tz = -5";
if ((_res).equals(BA.NumberToString(9))) { 
_tz = (float)(-5);};
 //BA.debugLineNum = 864;BA.debugLine="If res = 10 Then tz = -4";
if ((_res).equals(BA.NumberToString(10))) { 
_tz = (float)(-4);};
 //BA.debugLineNum = 865;BA.debugLine="If res = 11 Then tz = -3.5";
if ((_res).equals(BA.NumberToString(11))) { 
_tz = (float)(-3.5);};
 //BA.debugLineNum = 866;BA.debugLine="If res = 12 Then tz = -3";
if ((_res).equals(BA.NumberToString(12))) { 
_tz = (float)(-3);};
 //BA.debugLineNum = 867;BA.debugLine="If res = 13 Then tz = -2";
if ((_res).equals(BA.NumberToString(13))) { 
_tz = (float)(-2);};
 //BA.debugLineNum = 868;BA.debugLine="If res = 14 Then tz = -1";
if ((_res).equals(BA.NumberToString(14))) { 
_tz = (float)(-1);};
 //BA.debugLineNum = 869;BA.debugLine="If res = 15 Then tz = 0";
if ((_res).equals(BA.NumberToString(15))) { 
_tz = (float)(0);};
 //BA.debugLineNum = 870;BA.debugLine="If res = 16 Then tz = 1";
if ((_res).equals(BA.NumberToString(16))) { 
_tz = (float)(1);};
 //BA.debugLineNum = 871;BA.debugLine="If res = 17 Then tz = 2";
if ((_res).equals(BA.NumberToString(17))) { 
_tz = (float)(2);};
 //BA.debugLineNum = 872;BA.debugLine="If res = 18 Then tz = 3";
if ((_res).equals(BA.NumberToString(18))) { 
_tz = (float)(3);};
 //BA.debugLineNum = 873;BA.debugLine="If res = 19 Then tz = 3.5";
if ((_res).equals(BA.NumberToString(19))) { 
_tz = (float)(3.5);};
 //BA.debugLineNum = 874;BA.debugLine="If res = 20 Then tz = 4";
if ((_res).equals(BA.NumberToString(20))) { 
_tz = (float)(4);};
 //BA.debugLineNum = 875;BA.debugLine="If res = 21 Then tz = 5";
if ((_res).equals(BA.NumberToString(21))) { 
_tz = (float)(5);};
 //BA.debugLineNum = 876;BA.debugLine="If res = 22 Then tz = 5.5";
if ((_res).equals(BA.NumberToString(22))) { 
_tz = (float)(5.5);};
 //BA.debugLineNum = 877;BA.debugLine="If res = 23 Then tz = 6";
if ((_res).equals(BA.NumberToString(23))) { 
_tz = (float)(6);};
 //BA.debugLineNum = 878;BA.debugLine="If res = 24 Then tz = 6.5";
if ((_res).equals(BA.NumberToString(24))) { 
_tz = (float)(6.5);};
 //BA.debugLineNum = 879;BA.debugLine="If res = 25 Then tz = 7";
if ((_res).equals(BA.NumberToString(25))) { 
_tz = (float)(7);};
 //BA.debugLineNum = 880;BA.debugLine="If res = 26 Then tz = 7.5";
if ((_res).equals(BA.NumberToString(26))) { 
_tz = (float)(7.5);};
 //BA.debugLineNum = 881;BA.debugLine="If res = 27 Then tz = 8";
if ((_res).equals(BA.NumberToString(27))) { 
_tz = (float)(8);};
 //BA.debugLineNum = 882;BA.debugLine="If res = 28 Then tz = 8.5";
if ((_res).equals(BA.NumberToString(28))) { 
_tz = (float)(8.5);};
 //BA.debugLineNum = 883;BA.debugLine="If res = 29 Then tz = 9";
if ((_res).equals(BA.NumberToString(29))) { 
_tz = (float)(9);};
 //BA.debugLineNum = 884;BA.debugLine="If res = 30 Then tz = 9.5";
if ((_res).equals(BA.NumberToString(30))) { 
_tz = (float)(9.5);};
 //BA.debugLineNum = 885;BA.debugLine="If res = 31 Then tz = 10";
if ((_res).equals(BA.NumberToString(31))) { 
_tz = (float)(10);};
 //BA.debugLineNum = 886;BA.debugLine="If res = 32 Then tz = 10.5";
if ((_res).equals(BA.NumberToString(32))) { 
_tz = (float)(10.5);};
 //BA.debugLineNum = 887;BA.debugLine="If res = 33 Then tz = 11";
if ((_res).equals(BA.NumberToString(33))) { 
_tz = (float)(11);};
 //BA.debugLineNum = 888;BA.debugLine="If res = 34 Then tz = 11.5";
if ((_res).equals(BA.NumberToString(34))) { 
_tz = (float)(11.5);};
 //BA.debugLineNum = 889;BA.debugLine="If res = 35 Then tz = 12";
if ((_res).equals(BA.NumberToString(35))) { 
_tz = (float)(12);};
 //BA.debugLineNum = 890;BA.debugLine="If res = 36 Then tz = 12.5";
if ((_res).equals(BA.NumberToString(36))) { 
_tz = (float)(12.5);};
 //BA.debugLineNum = 891;BA.debugLine="If res = 37 Then tz = 13";
if ((_res).equals(BA.NumberToString(37))) { 
_tz = (float)(13);};
 };
 //BA.debugLineNum = 894;BA.debugLine="Return tz";
if (true) return BA.NumberToString(_tz);
 //BA.debugLineNum = 895;BA.debugLine="End Sub";
return "";
}
public static String  _vv5() throws Exception{
String _d = "";
String _s = "";
long _l = 0L;
int _res = 0;
 //BA.debugLineNum = 742;BA.debugLine="Sub GetTimeZoneOffset";
 //BA.debugLineNum = 744;BA.debugLine="Dim d, s As String";
_d = "";
_s = "";
 //BA.debugLineNum = 745;BA.debugLine="Dim l As Long";
_l = 0L;
 //BA.debugLineNum = 746;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 748;BA.debugLine="s = DateTime.DateFormat";
_s = anywheresoftware.b4a.keywords.Common.DateTime.getDateFormat();
 //BA.debugLineNum = 750;BA.debugLine="DateTime.DateFormat = \"MM/dd/yyyy HH:mm:ss\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("MM/dd/yyyy HH:mm:ss");
 //BA.debugLineNum = 751;BA.debugLine="l = DateTime.Now";
_l = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 752;BA.debugLine="d = DateTime.Date(l) & \" GMT\"";
_d = anywheresoftware.b4a.keywords.Common.DateTime.Date(_l)+" GMT";
 //BA.debugLineNum = 754;BA.debugLine="DateTime.DateFormat = \"MM/dd/yyyy HH:mm:ss z\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("MM/dd/yyyy HH:mm:ss z");
 //BA.debugLineNum = 755;BA.debugLine="res = -Round((l - DateTime.DateParse(d))/3600000)";
_res = (int)(-anywheresoftware.b4a.keywords.Common.Round((_l-anywheresoftware.b4a.keywords.Common.DateTime.DateParse(_d))/(double)3600000));
 //BA.debugLineNum = 757;BA.debugLine="DateTime.DateFormat = s";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat(_s);
 //BA.debugLineNum = 759;BA.debugLine="Return res";
if (true) return BA.NumberToString(_res);
 //BA.debugLineNum = 760;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim btnChange, btnDate, btnHelp, btnPrevious, btnNext, btnWheel_Text, getTime As Button";
mostCurrent._btnchange = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btndate = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnhelp = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnprevious = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnnext = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._btnwheel_text = new anywheresoftware.b4a.objects.ButtonWrapper();
mostCurrent._vvv3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 19;BA.debugLine="Dim Bmp1, Bmp2 As Bitmap";
mostCurrent._v5 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
mostCurrent._v6 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 20;BA.debugLine="Dim EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Dim chkDebug As CheckBox";
mostCurrent._chkdebug = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 22;BA.debugLine="Dim cvsLayer As Canvas";
mostCurrent._vv1 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Dim HamburgFont As Typeface";
mostCurrent._v7 = new anywheresoftware.b4a.keywords.constants.TypefaceWrapper();
 //BA.debugLineNum = 26;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 5;BA.debugLine="Dim swe0 As SweDate";
_vv3 = new anywheresoftware.b4a.sample1.SweDate();
 //BA.debugLineNum = 6;BA.debugLine="Dim swe1 As SwissEph";
_vvv2 = new anywheresoftware.b4a.sample1.SwissEph();
 //BA.debugLineNum = 8;BA.debugLine="Dim asp_names(7), last_interp_text, month_names(13), natal_data, p_names(10), prev_text, transit_data As String";
_asp_names = new String[(int)(7)];
java.util.Arrays.fill(_asp_names,"");
_last_interp_text = "";
_month_names = new String[(int)(13)];
java.util.Arrays.fill(_month_names,"");
_natal_data = "";
_p_names = new String[(int)(10)];
java.util.Arrays.fill(_p_names,"");
_prev_text = "";
_transit_data = "";
 //BA.debugLineNum = 9;BA.debugLine="Dim natal_data_header, transit_data_header As String";
_natal_data_header = "";
_transit_data_header = "";
 //BA.debugLineNum = 10;BA.debugLine="Dim aspect_present(10, 10), flag_help, pl_glyph(10), sign_glyph(13), spot_filled(360) As Int";
_aspect_present = new int[(int)(10)][];
{
int d0 = _aspect_present.length;
int d1 = (int)(10);
for (int i0 = 0;i0 < d0;i0++) {
_aspect_present[i0] = new int[d1];
}
}
;
_flag_help = 0;
_pl_glyph = new int[(int)(10)];
;
_sign_glyph = new int[(int)(13)];
;
_spot_filled = new int[(int)(360)];
;
 //BA.debugLineNum = 11;BA.debugLine="Dim tz_offset As Float";
_tz_offset = 0f;
 //BA.debugLineNum = 12;BA.debugLine="Dim current_JD, d2r, Natal(10), Transit(10) As Double";
_current_jd = 0;
_v0 = 0;
_vv4 = new double[(int)(10)];
;
_vvv1 = new double[(int)(10)];
;
 //BA.debugLineNum = 13;BA.debugLine="End Sub";
return "";
}
public static int  _vvv4(String _s) throws Exception{
 //BA.debugLineNum = 715;BA.debugLine="Sub String2Integer(s As String) As Int";
 //BA.debugLineNum = 716;BA.debugLine="Return s";
if (true) return (int)(Double.parseDouble(_s));
 //BA.debugLineNum = 717;BA.debugLine="End Sub";
return 0;
}
}
